﻿using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

/* --- © 2022 JaxZoa <JaxZoa@gmail.com> --- */


namespace JaxPlugins
{

    public class BodyController_Standing : BodyController
    {
        #region JSON Storables definitions

        /* Storables */        

        #region Step Cycle Storables

        /* Step Cycle parameters */

        protected JSONStorableFloat js_StepsDuration;
        protected JSONStorableFloat js_StepsDelay;

        protected JSONStorableFloat js_StepsXOffset;
        protected JSONStorableFloat js_StepsXOffsetIdle;
        protected JSONStorableFloat js_StepsYOffset;

        protected JSONStorableFloat js_KneeXOffsetKneelingIdle;
        protected JSONStorableFloat js_KneeXOffsetKneelingMoving;
        protected JSONStorableFloat js_KneeYOffsetKneeling;

        protected JSONStorableFloat js_DurationRandom_Min;
        protected JSONStorableFloat js_DurationRandom_Max;

        protected JSONStorableFloat js_XOffsetRandom_Min;
        protected JSONStorableFloat js_XOffsetRandom_Max;

        #endregion

        #region Dance Mode Storables

        /* Dance Mode parameters */

        protected JSONStorableBool js_DanceMode;
        protected JSONStorableFloat js_DanceAmplitude;

        protected JSONStorableBool js_MoveKneesOnBothSteps;
        protected JSONStorableBool js_MoveFeetOnBothSteps;

        protected JSONStorableBool  js_RandomAmplitude;
        protected JSONStorableFloat js_DanceAmplitudeDelayMult;
        protected JSONStorableFloat js_DanceAmplitudeChange;
        protected JSONStorableFloat js_DanceAmplitudeChangeLimit;

        protected JSONStorableBool js_AutoRotate;
        protected JSONStorableFloat js_AutoRotDelayMult;
        protected JSONStorableFloat js_AutoRotAngleChangeMin;
        protected JSONStorableFloat js_AutoRotAngleChangeMax;
        protected JSONStorableFloat js_AutoRotAngleMin;
        protected JSONStorableFloat js_AutoRotAngleMax;

        protected JSONStorableBool js_HipsAutoRotate;
        protected JSONStorableFloat js_HipsAutoRotDelayMult;
        protected JSONStorableFloat js_HipsAutoRotAngleChangeMin;
        protected JSONStorableFloat js_HipsAutoRotAngleChangeMax;
        protected JSONStorableFloat js_HipsAutoRotAngleMin;
        protected JSONStorableFloat js_HipsAutoRotAngleMax;

        protected JSONStorableBool js_ChestAutoRotate;
        protected JSONStorableFloat js_ChestAutoRotDelayMult;
        protected JSONStorableFloat js_ChestAutoRotAngleChangeMin;
        protected JSONStorableFloat js_ChestAutoRotAngleChangeMax;
        protected JSONStorableFloat js_ChestAutoRotAngleMin;
        protected JSONStorableFloat js_ChestAutoRotAngleMax;

        protected JSONStorableBool js_NeckAutoRotate;
        protected JSONStorableFloat js_NeckAutoRotDelayMult;
        protected JSONStorableFloat js_NeckAutoRotAngleChangeMin;
        protected JSONStorableFloat js_NeckAutoRotAngleChangeMax;
        protected JSONStorableFloat js_NeckAutoRotAngleMin;
        protected JSONStorableFloat js_NeckAutoRotAngleMax;


        #endregion

        #region Actions Storables

        protected JSONStorableFloat js_Action_StepDurationChange;
        protected JSONStorableFloat js_Action_DanceAmplitudeChange;
        protected JSONStorableFloat js_Action_RotationOffsetChange;

        #endregion

        #region Body Control Toggles Storables

        /* Body Control Toggles */

        protected JSONStorableBool js_UpdateHipControl;
        protected JSONStorableBool js_UpdateChestControl;
        protected JSONStorableBool js_UpdateNeckControl;
        protected JSONStorableBool js_UpdateRFootControl;
        protected JSONStorableBool js_UpdateLFootControl;
        protected JSONStorableBool js_UpdateRKneeControl;
        protected JSONStorableBool js_UpdateLKneeControl;
        protected JSONStorableBool js_UpdateRShoulderControl;
        protected JSONStorableBool js_UpdateLShoulderControl;
        protected JSONStorableBool js_UpdateRHandControl;
        protected JSONStorableBool js_UpdateLHandControl;
        protected JSONStorableBool js_UpdateRElbowControl;
        protected JSONStorableBool js_UpdateLElbowControl;

        #endregion

        #region Preset Storables

        protected JSONStorableBool js_TogglePresetUpdate_StepDuration;
        protected JSONStorableBool js_TogglePresetUpdate_DanceAmplitude;

        #endregion

        #region Full Body Storables
        protected JSONStorableFloat js_TrashFloat;

        /* Fullbody Parameters */

        protected JSONStorableBool js_Standing;

        protected JSONStorableBool js_SwitchStanceAuto;
        protected JSONStorableBool js_AutoAdaptHeight;
        protected JSONStorableFloat js_BodyHeight;
        protected JSONStorableFloat js_BodyYaw;
        protected JSONStorableFloat js_BodyPitch;
        protected JSONStorableFloat js_BodyRoll;

        protected JSONStorableFloat js_Step_BodyHeight;
        protected JSONStorableFloat js_Step_BodyYaw;
        protected JSONStorableFloat js_Step_BodyPitch;
        protected JSONStorableFloat js_Step_BodyRoll;

        protected JSONStorableFloat js_Step_FullBody_MidPoint;
        protected JSONStorableFloat js_Step_FullBody_Sharpness;

        #endregion

        #region Kneeling Storables

        /* Kneeling parameters */

        protected JSONStorableFloat js_KneeStepHeightKneeling;
        protected JSONStorableFloat js_KneeStepBowKneeling;

        protected JSONStorableFloat js_LegsYawKneeling;
        protected JSONStorableFloat js_LegsPitchKneeling;
        protected JSONStorableFloat js_LegsRollKneeling;

        #endregion

        #region Legs Storables

        /* Left Foot Parameters */

        protected JSONStorableFloat js_LFootSide;
        protected JSONStorableFloat js_LFootUpDown;
        protected JSONStorableFloat js_LFootForward;
        protected JSONStorableFloat js_LFootYaw;
        protected JSONStorableFloat js_LFootPitch;
        protected JSONStorableFloat js_LFootRoll;
        protected JSONStorableFloat js_LFootStepSide;
        protected JSONStorableFloat js_LFootStepUpDown;
        protected JSONStorableFloat js_LFootStepForward;
        protected JSONStorableFloat js_LFootStepYaw;
        protected JSONStorableFloat js_LFootStepPitch;
        protected JSONStorableFloat js_LFootStepRoll;

        protected JSONStorableFloat js_Step_LeftFoot_MidPoint;
        protected JSONStorableFloat js_Step_LeftFoot_Sharpness;

        /* Right Foot Parameters */

        protected JSONStorableFloat js_RFootSide;
        protected JSONStorableFloat js_RFootUpDown;
        protected JSONStorableFloat js_RFootForward;
        protected JSONStorableFloat js_RFootYaw;
        protected JSONStorableFloat js_RFootPitch;
        protected JSONStorableFloat js_RFootRoll;
        protected JSONStorableFloat js_RFootStepSide;
        protected JSONStorableFloat js_RFootStepUpDown;
        protected JSONStorableFloat js_RFootStepForward;
        protected JSONStorableFloat js_RFootStepYaw;
        protected JSONStorableFloat js_RFootStepPitch;
        protected JSONStorableFloat js_RFootStepRoll;

        protected JSONStorableFloat js_Step_RightFoot_MidPoint;
        protected JSONStorableFloat js_Step_RightFoot_Sharpness;

        /* Left Knee Parameters */

        protected JSONStorableFloat js_LKneeSide;
        protected JSONStorableFloat js_LKneeUpDown;
        protected JSONStorableFloat js_LKneeForward;
        protected JSONStorableFloat js_LKneeStepSide;
        protected JSONStorableFloat js_LKneeStepUpDown;
        protected JSONStorableFloat js_LKneeStepForward;

        protected JSONStorableFloat js_Step_LeftKnee_MidPoint;
        protected JSONStorableFloat js_Step_LeftKnee_Sharpness;


        /* Right Knee Parameters */

        protected JSONStorableFloat js_RKneeSide;
        protected JSONStorableFloat js_RKneeUpDown;
        protected JSONStorableFloat js_RKneeForward;
        protected JSONStorableFloat js_RKneeStepSide;
        protected JSONStorableFloat js_RKneeStepUpDown;
        protected JSONStorableFloat js_RKneeStepForward;

        protected JSONStorableFloat js_Step_RightKnee_MidPoint;
        protected JSONStorableFloat js_Step_RightKnee_Sharpness;


        #endregion

        #region Hips/Neck/Torso storables

        /* Hips Parameters */

        protected JSONStorableFloat js_HipsSide;
        protected JSONStorableFloat js_HipsUpDown;
        protected JSONStorableFloat js_HipsForward;
        protected JSONStorableFloat js_HipsYaw;
        protected JSONStorableFloat js_HipsPitch;
        protected JSONStorableFloat js_HipsRoll;
        protected JSONStorableFloat js_HipsStepSide;
        protected JSONStorableFloat js_HipsStepUpDown;
        protected JSONStorableFloat js_HipsStepForward;
        protected JSONStorableFloat js_HipsStepYaw;
        protected JSONStorableFloat js_HipsStepPitch;
        protected JSONStorableFloat js_HipsStepRoll;

        protected JSONStorableFloat js_Step_Hips_MidPoint;
        protected JSONStorableFloat js_Step_Hips_Sharpness;

        /* Chest Parameters */

        protected JSONStorableFloat js_ChestSide;
        protected JSONStorableFloat js_ChestUpDown;
        protected JSONStorableFloat js_ChestForward;
        protected JSONStorableFloat js_ChestYaw;
        protected JSONStorableFloat js_ChestPitch;
        protected JSONStorableFloat js_ChestRoll;
        protected JSONStorableFloat js_ChestStepSide;
        protected JSONStorableFloat js_ChestStepUpDown;
        protected JSONStorableFloat js_ChestStepForward;
        protected JSONStorableFloat js_ChestStepYaw;
        protected JSONStorableFloat js_ChestStepPitch;
        protected JSONStorableFloat js_ChestStepRoll;

        protected JSONStorableFloat js_Step_Chest_MidPoint;
        protected JSONStorableFloat js_Step_Chest_Sharpness;


        /* Neck Parameters */

        protected JSONStorableFloat js_NeckSide;
        protected JSONStorableFloat js_NeckUpDown;
        protected JSONStorableFloat js_NeckForward;
        protected JSONStorableFloat js_NeckYaw;
        protected JSONStorableFloat js_NeckPitch;
        protected JSONStorableFloat js_NeckRoll;
        protected JSONStorableFloat js_NeckStepSide;
        protected JSONStorableFloat js_NeckStepUpDown;
        protected JSONStorableFloat js_NeckStepForward;
        protected JSONStorableFloat js_NeckStepYaw;
        protected JSONStorableFloat js_NeckStepPitch;
        protected JSONStorableFloat js_NeckStepRoll;

        protected JSONStorableFloat js_Step_Neck_MidPoint;
        protected JSONStorableFloat js_Step_Neck_Sharpness;

        #endregion

        #region Arms Storables

        /* Left Arm Parameters */

        protected JSONStorableFloat js_LShoulderSide;
        protected JSONStorableFloat js_LShoulderUpDown;
        protected JSONStorableFloat js_LShoulderForward;
        protected JSONStorableFloat js_LHandSide;
        protected JSONStorableFloat js_LHandUpDown;
        protected JSONStorableFloat js_LHandForward;
        protected JSONStorableFloat js_LHandYaw;
        protected JSONStorableFloat js_LHandPitch;
        protected JSONStorableFloat js_LHandRoll;
        protected JSONStorableFloat js_LElbowSide;
        protected JSONStorableFloat js_LElbowUpDown;
        protected JSONStorableFloat js_LElbowForward;
        protected JSONStorableFloat js_LShoulderStepSide;
        protected JSONStorableFloat js_LShoulderStepUpDown;
        protected JSONStorableFloat js_LShoulderStepForward;
        protected JSONStorableFloat js_LHandStepSide;
        protected JSONStorableFloat js_LHandStepUpDown;
        protected JSONStorableFloat js_LHandStepForward;
        protected JSONStorableFloat js_LHandStepYaw;
        protected JSONStorableFloat js_LHandStepPitch;
        protected JSONStorableFloat js_LHandStepRoll;
        protected JSONStorableFloat js_LElbowStepSide;
        protected JSONStorableFloat js_LElbowStepUpDown;
        protected JSONStorableFloat js_LElbowStepForward;

        protected JSONStorableFloat js_Step_LeftShoulder_MidPoint;
        protected JSONStorableFloat js_Step_LeftShoulder_Sharpness;
        protected JSONStorableFloat js_Step_LeftElbow_MidPoint;
        protected JSONStorableFloat js_Step_LeftElbow_Sharpness;
        protected JSONStorableFloat js_Step_LeftHand_MidPoint;
        protected JSONStorableFloat js_Step_LeftHand_Sharpness;

        /* Right Arm Parameters */

        protected JSONStorableFloat js_RShoulderSide;               
        protected JSONStorableFloat js_RShoulderUpDown;
        protected JSONStorableFloat js_RShoulderForward;
        protected JSONStorableFloat js_RHandSide;
        protected JSONStorableFloat js_RHandUpDown;
        protected JSONStorableFloat js_RHandForward;
        protected JSONStorableFloat js_RHandYaw;
        protected JSONStorableFloat js_RHandPitch;
        protected JSONStorableFloat js_RHandRoll;
        protected JSONStorableFloat js_RElbowSide;
        protected JSONStorableFloat js_RElbowUpDown;
        protected JSONStorableFloat js_RElbowForward;
        protected JSONStorableFloat js_RShoulderStepSide;
        protected JSONStorableFloat js_RShoulderStepUpDown;
        protected JSONStorableFloat js_RShoulderStepForward;
        protected JSONStorableFloat js_RHandStepSide;
        protected JSONStorableFloat js_RHandStepUpDown;
        protected JSONStorableFloat js_RHandStepForward;
        protected JSONStorableFloat js_RHandStepYaw;
        protected JSONStorableFloat js_RHandStepPitch;
        protected JSONStorableFloat js_RHandStepRoll;
        protected JSONStorableFloat js_RElbowStepSide;
        protected JSONStorableFloat js_RElbowStepUpDown;
        protected JSONStorableFloat js_RElbowStepForward;

        protected JSONStorableFloat js_Step_RightShoulder_MidPoint;
        protected JSONStorableFloat js_Step_RightShoulder_Sharpness;
        protected JSONStorableFloat js_Step_RightElbow_MidPoint;
        protected JSONStorableFloat js_Step_RightElbow_Sharpness;
        protected JSONStorableFloat js_Step_RightHand_MidPoint;
        protected JSONStorableFloat js_Step_RightHand_Sharpness;

        protected bool isActive = false;

        #endregion

        /* End Storables */

        #endregion

        #region Init Storables

        public void InitStorables()
        {
            InitStorables_Global();
            InitStorables_Action();
            InitStorables_Presets();
            InitStorables_ControlToggles();
            InitStorables_Kneeling();
            InitStorables_Dance();
            InitStorables_StepCycle();

            InitStorables_Feet();
            InitStorables_Hips();
            InitStorables_Chest();
            InitStorables_Neck();
            InitStorables_Knees();
            InitStorables_Arms();
        }

        public void InitStorables_Global()
        {
            js_TrashFloat = new JSONStorableFloat("Trash Float", 0, 0, 0);

            manager.RegisterFloat(js_TrashFloat);

            /* Global */

            js_Standing = new JSONStorableBool("Standing", true);

            js_SwitchStanceAuto = new JSONStorableBool("Auto Kneel", true);
            js_AutoAdaptHeight = new JSONStorableBool("Auto Adapt Height", false);

            js_BodyHeight = new JSONStorableFloat("BodyHeight", 1f, 0.02f, 1.3f);
            js_BodyYaw = new JSONStorableFloat("BodyYaw", 0, -175f, 175f);
            js_BodyPitch = new JSONStorableFloat("BodyPitch", 5f, -175f, 175f);
            js_BodyRoll = new JSONStorableFloat("BodyRoll", 0, -90, 90);

            js_Step_BodyHeight = new JSONStorableFloat("Step_BodyHeight", 0.06f, -0.5f, 0.5f);
            js_Step_BodyYaw = new JSONStorableFloat("Step_BodyYaw", 0, -180f, 180f);
            js_Step_BodyPitch = new JSONStorableFloat("Step_BodyPitch", 0, -180f, 180f);
            js_Step_BodyRoll = new JSONStorableFloat("Step_BodyRoll", 0, -180f, 180f);

            js_Step_FullBody_MidPoint = new JSONStorableFloat("StepCurve_FullBody_MidPoint", 0.5f, 0.1f, 0.9f);
            js_Step_FullBody_Sharpness = new JSONStorableFloat("StepCurve_FullBody_Sharpness", 0.5f, 0.1f, 0.9f);

            manager.RegisterBool(js_Standing);
            manager.RegisterBool(js_SwitchStanceAuto);
            manager.RegisterBool(js_AutoAdaptHeight);
            manager.RegisterFloat(js_BodyHeight);
            manager.RegisterFloat(js_BodyYaw);
            manager.RegisterFloat(js_BodyPitch);
            manager.RegisterFloat(js_BodyRoll);
            manager.RegisterFloat(js_Step_BodyHeight);
            manager.RegisterFloat(js_Step_BodyYaw);
            manager.RegisterFloat(js_Step_BodyPitch);
            manager.RegisterFloat(js_Step_BodyRoll);

            manager.RegisterFloat(js_Step_FullBody_MidPoint);
            manager.RegisterFloat(js_Step_FullBody_Sharpness);
        }

        public void InitStorables_Action()
        {
            /* Presets Actions */

            JSONStorableUrl _js_LoadPresetURL = new JSONStorableUrl("Load Fullbody Preset Path", CLS.FBP_DIR, "", CLS.FBP_DIR + "\\");
            JSONStorableActionPresetFilePath _js_PresetAction = new JSONStorableActionPresetFilePath("Load Fullbody Preset File", manager.LoadFullBodyPreset, _js_LoadPresetURL);

            manager.RegisterPresetFilePathAction(_js_PresetAction);
            manager.RegisterUrl(_js_LoadPresetURL);

            _js_LoadPresetURL = new JSONStorableUrl("Load Full Trigger Path", CLS.TP_DIR, "", CLS.TP_DIR + "\\");
            _js_PresetAction = new JSONStorableActionPresetFilePath("Load Full Trigger File", manager.LoadTriggerFullTriggerPreset, _js_LoadPresetURL);

            manager.RegisterPresetFilePathAction(_js_PresetAction);
            manager.RegisterUrl(_js_LoadPresetURL);

            _js_LoadPresetURL = new JSONStorableUrl("Load Destination Reached Trigger Path", CLS.TP_DIR, "", CLS.TP_DIR + "\\");
            _js_PresetAction = new JSONStorableActionPresetFilePath("Load Destination Reached Trigger File", manager.LoadTriggerDestinationReachedPreset, _js_LoadPresetURL);

            manager.RegisterPresetFilePathAction(_js_PresetAction);
            manager.RegisterUrl(_js_LoadPresetURL);


            /* Dance Actions Interval Control */

            js_Action_DanceAmplitudeChange = new JSONStorableFloat("ActionDanceAmplitudeChange", 0.05f, 0.01f, 0.5f);
            manager.RegisterFloat(js_Action_DanceAmplitudeChange);

            js_Action_StepDurationChange = new JSONStorableFloat("ActionStepDurationChange", 0.05f, 0.01f, 0.5f);
            manager.RegisterFloat(js_Action_StepDurationChange);

            js_Action_RotationOffsetChange = new JSONStorableFloat("ActionRotationOffsetChange", 15f, 5f, 180f);
            manager.RegisterFloat(js_Action_RotationOffsetChange);


            /* CLS Dance Actions */

            JSONStorableAction _js_Action = new JSONStorableAction("Reset Steps", Callback_ResetStepTime);
            manager.RegisterAction(_js_Action);

            _js_Action = new JSONStorableAction("Increment Step Duration", Action_IncrementStepDuration);
            manager.RegisterAction(_js_Action);

            _js_Action = new JSONStorableAction("Decrement Step Duration", Action_DecrementStepDuration);
            manager.RegisterAction(_js_Action);

            _js_Action = new JSONStorableAction("Increment Dance Amplitude", Action_IncrementDanceAmplitude);
            manager.RegisterAction(_js_Action);

            _js_Action = new JSONStorableAction("Decrement Dance Amplitude", Action_DecrementDanceAmplitude);
            manager.RegisterAction(_js_Action);

            _js_Action = new JSONStorableAction("Increment Rotation Offset", Action_IncrementRotationOffset);
            manager.RegisterAction(_js_Action);

            _js_Action = new JSONStorableAction("Decrement Rotation Offset", Action_DecrementRotationOffset);
            manager.RegisterAction(_js_Action);

            _js_Action = new JSONStorableAction("Sync Beat", _Action_SyncBeat);
            manager.RegisterAction(_js_Action);


        }

        public void InitStorables_Presets()
        {
            js_TogglePresetUpdate_StepDuration = new JSONStorableBool("Update Step Duration", true);
            js_TogglePresetUpdate_DanceAmplitude = new JSONStorableBool("Update Dance Amplitude", true);

            manager.RegisterBool(js_TogglePresetUpdate_StepDuration);
            manager.RegisterBool(js_TogglePresetUpdate_DanceAmplitude);
        }

        public void InitStorables_ControlToggles()
        {
            /* Body Control Toggles */

            js_UpdateHipControl = new JSONStorableBool("Update Hip", true);
            js_UpdateChestControl = new JSONStorableBool("Update Chest", true);
            js_UpdateNeckControl = new JSONStorableBool("Update Neck", true);
            js_UpdateRFootControl = new JSONStorableBool("Update Right Foot", true);
            js_UpdateLFootControl = new JSONStorableBool("Update Left Foot", true);
            js_UpdateRKneeControl = new JSONStorableBool("Update Right Knee", true);
            js_UpdateLKneeControl = new JSONStorableBool("Update Left Knee", true);
            js_UpdateRShoulderControl = new JSONStorableBool("Update Right Shoulder", true);
            js_UpdateLShoulderControl = new JSONStorableBool("Update Left Shoulder", true);
            js_UpdateRHandControl = new JSONStorableBool("Update Right Hand", true);
            js_UpdateLHandControl = new JSONStorableBool("Update Left Hand", true);
            js_UpdateRElbowControl = new JSONStorableBool("Update Right Elbow", true);
            js_UpdateLElbowControl = new JSONStorableBool("Update Left Elbow", true);

            js_UpdateHipControl.setCallbackFunction = Callback_UpdateBodyControlToggles;
            js_UpdateChestControl.setCallbackFunction = Callback_UpdateBodyControlToggles;
            js_UpdateNeckControl.setCallbackFunction = Callback_UpdateBodyControlToggles;
            js_UpdateRFootControl.setCallbackFunction = Callback_UpdateBodyControlToggles;
            js_UpdateLFootControl.setCallbackFunction = Callback_UpdateBodyControlToggles;
            js_UpdateRKneeControl.setCallbackFunction = Callback_UpdateBodyControlToggles;
            js_UpdateLKneeControl.setCallbackFunction = Callback_UpdateBodyControlToggles;
            js_UpdateRShoulderControl.setCallbackFunction = Callback_UpdateBodyControlToggles;
            js_UpdateLShoulderControl.setCallbackFunction = Callback_UpdateBodyControlToggles;
            js_UpdateRHandControl.setCallbackFunction = Callback_UpdateBodyControlToggles;
            js_UpdateLHandControl.setCallbackFunction = Callback_UpdateBodyControlToggles;
            js_UpdateRElbowControl.setCallbackFunction = Callback_UpdateBodyControlToggles;
            js_UpdateLElbowControl.setCallbackFunction = Callback_UpdateBodyControlToggles;

            manager.RegisterBool(js_UpdateHipControl);
            manager.RegisterBool(js_UpdateChestControl);
            manager.RegisterBool(js_UpdateNeckControl);
            manager.RegisterBool(js_UpdateRFootControl);
            manager.RegisterBool(js_UpdateLFootControl);
            manager.RegisterBool(js_UpdateRKneeControl);
            manager.RegisterBool(js_UpdateLKneeControl);
            manager.RegisterBool(js_UpdateRShoulderControl);
            manager.RegisterBool(js_UpdateLShoulderControl);
            manager.RegisterBool(js_UpdateRHandControl);
            manager.RegisterBool(js_UpdateLHandControl);
            manager.RegisterBool(js_UpdateRElbowControl);
            manager.RegisterBool(js_UpdateLElbowControl);
        }

        public void InitStorables_Kneeling()
        {
            /* Kneeling */

            js_KneeXOffsetKneelingIdle = new JSONStorableFloat("Knee Spacing Idle", 0.16f, 0.03f, 0.75f);
            js_KneeXOffsetKneelingMoving = new JSONStorableFloat("Knee Spacing Moving", 0.16f, 0.03f, 0.75f);
            js_KneeYOffsetKneeling = new JSONStorableFloat("Knee Ground Offset", 0.06f, 0.01f, 0.5f);

            js_KneeXOffsetKneelingIdle.setCallbackFunction = Callback_UpdateStepCycleParameters;
            js_KneeXOffsetKneelingMoving.setCallbackFunction = Callback_UpdateStepCycleParameters;
            js_KneeYOffsetKneeling.setCallbackFunction = Callback_UpdateStepCycleParameters;

            js_LegsYawKneeling = new JSONStorableFloat("Feet Spacing", 0, -45f, 45f);
            js_LegsPitchKneeling = new JSONStorableFloat("Feet Up", 0, 0f, 90f);
            js_LegsRollKneeling = new JSONStorableFloat("Legs Rotation", 0, -90, 90f);

            js_KneeStepHeightKneeling = new JSONStorableFloat("Knee Step Height", 0.15f, 0, 0.5f);
            js_KneeStepBowKneeling = new JSONStorableFloat("Knee Step Bow", 0.15f, -0.5f, 0.5f);

            manager.RegisterFloat(js_KneeXOffsetKneelingIdle);
            manager.RegisterFloat(js_KneeXOffsetKneelingMoving);
            manager.RegisterFloat(js_KneeYOffsetKneeling);

            manager.RegisterFloat(js_LegsYawKneeling);
            manager.RegisterFloat(js_LegsPitchKneeling);
            manager.RegisterFloat(js_LegsRollKneeling);

            manager.RegisterFloat(js_KneeStepHeightKneeling);
            manager.RegisterFloat(js_KneeStepBowKneeling);
        }

        public void InitStorables_Dance()
        {
            /* Dance */

            js_DanceMode = new JSONStorableBool("Dance Mode", false);
            js_DanceAmplitude = new JSONStorableFloat("Dance Amplitude", 1, 0, 1, false);

            js_DanceMode.setCallbackFunction = Callback_UpdateStepInPlace;
            js_DanceAmplitude.setCallbackFunction = Callback_UpdateStepCycleParameters;

            js_RandomAmplitude = new JSONStorableBool("Random Amplitude", false);
            js_DanceAmplitudeDelayMult = new JSONStorableFloat("Dance Amplitude Change Duration", 1, 0, 10);
            js_DanceAmplitudeChange = new JSONStorableFloat("Dance Amplitude Change", 0.1f, 0, 10);
            js_DanceAmplitudeChangeLimit = new JSONStorableFloat("Dance Amplitude Change Limit", 0.3f, 0, 10);

            js_MoveKneesOnBothSteps = new JSONStorableBool("Move Knees Both Steps", false);
            js_MoveFeetOnBothSteps = new JSONStorableBool("Move Feet Both Steps", false);

            js_AutoRotate = new JSONStorableBool("Auto Rotate", false);
            js_AutoRotate.setCallbackFunction = Callback_UpdateAutoRotate;

            js_AutoRotAngleChangeMin = new JSONStorableFloat("Auto Rot Angle Change Min", 5, 0, 180);
            js_AutoRotAngleChangeMax = new JSONStorableFloat("Auto Rot Angle Change Max", 30, 0, 180);
            js_AutoRotAngleMin = new JSONStorableFloat("Auto Rot Angle Left", 45, 0, 180);
            js_AutoRotAngleMax = new JSONStorableFloat("Auto Rot Angle Right", 45, 0, 180);
            js_AutoRotDelayMult = new JSONStorableFloat("Auto Rot Speed", 2, 0, 10);

            js_HipsAutoRotate = new JSONStorableBool("Auto Rotate Hips", false);
            js_HipsAutoRotDelayMult = new JSONStorableFloat("Hips Auto Rot Duration", 1, 0, 10);
            js_HipsAutoRotAngleChangeMin = new JSONStorableFloat("Hips Auto Rot Change Min", 5, 0, 90);
            js_HipsAutoRotAngleChangeMax = new JSONStorableFloat("Hips Auto Rot Change Max", 30, 0, 90);
            js_HipsAutoRotAngleMin = new JSONStorableFloat("Hips Auto Rot Angle Left", 45, 0, 90);
            js_HipsAutoRotAngleMax = new JSONStorableFloat("Hips Auto Rot Angle Right", 45, 0, 90);

            js_ChestAutoRotate = new JSONStorableBool("Auto Rotate Chest", false);
            js_ChestAutoRotDelayMult = new JSONStorableFloat("Chest Auto Rot Duration", 1, 0, 10);
            js_ChestAutoRotAngleChangeMin = new JSONStorableFloat("Chest Auto Rot Change Min", 5, 0, 90);
            js_ChestAutoRotAngleChangeMax = new JSONStorableFloat("Chest Auto Rot Change Max", 30, 0, 90);
            js_ChestAutoRotAngleMin = new JSONStorableFloat("Chest Auto Rot Angle Left", 45, 0, 90);
            js_ChestAutoRotAngleMax = new JSONStorableFloat("Chest Auto Rot Angle Right", 45, 0, 90);

            js_NeckAutoRotate = new JSONStorableBool("Auto Rotate Neck", false);
            js_NeckAutoRotDelayMult = new JSONStorableFloat("Neck Auto Rot Duration", 1, 0, 10);
            js_NeckAutoRotAngleChangeMin = new JSONStorableFloat("Neck Auto Rot Change Min", 5, 0, 90);
            js_NeckAutoRotAngleChangeMax = new JSONStorableFloat("Neck Auto Rot Change Max", 30, 0, 90);
            js_NeckAutoRotAngleMin = new JSONStorableFloat("Neck Auto Rot Angle Left", 45, 0, 90);
            js_NeckAutoRotAngleMax = new JSONStorableFloat("Neck Auto Rot Angle Right", 45, 0, 90);

            manager.RegisterBool(js_DanceMode);
            manager.RegisterFloat(js_DanceAmplitude);

            manager.RegisterBool(js_RandomAmplitude);
            manager.RegisterFloat(js_DanceAmplitudeDelayMult);
            manager.RegisterFloat(js_DanceAmplitudeChange);
            manager.RegisterFloat(js_DanceAmplitudeChangeLimit);

            manager.RegisterBool(js_MoveKneesOnBothSteps);
            manager.RegisterBool(js_MoveFeetOnBothSteps);

            manager.RegisterBool(js_AutoRotate);
            manager.RegisterFloat(js_AutoRotAngleChangeMin);
            manager.RegisterFloat(js_AutoRotAngleChangeMax);
            manager.RegisterFloat(js_AutoRotAngleMin);
            manager.RegisterFloat(js_AutoRotAngleMax);
            manager.RegisterFloat(js_AutoRotDelayMult);

            manager.RegisterBool(js_HipsAutoRotate);
            manager.RegisterFloat(js_HipsAutoRotDelayMult);
            manager.RegisterFloat(js_HipsAutoRotAngleChangeMin);
            manager.RegisterFloat(js_HipsAutoRotAngleChangeMax);
            manager.RegisterFloat(js_HipsAutoRotAngleMin);
            manager.RegisterFloat(js_HipsAutoRotAngleMax);

            manager.RegisterBool(js_ChestAutoRotate);
            manager.RegisterFloat(js_ChestAutoRotDelayMult);
            manager.RegisterFloat(js_ChestAutoRotAngleChangeMin);
            manager.RegisterFloat(js_ChestAutoRotAngleChangeMax);
            manager.RegisterFloat(js_ChestAutoRotAngleMin);
            manager.RegisterFloat(js_ChestAutoRotAngleMax);

            manager.RegisterBool(js_NeckAutoRotate);
            manager.RegisterFloat(js_NeckAutoRotDelayMult);
            manager.RegisterFloat(js_NeckAutoRotAngleChangeMin);
            manager.RegisterFloat(js_NeckAutoRotAngleChangeMax);
            manager.RegisterFloat(js_NeckAutoRotAngleMin);
            manager.RegisterFloat(js_NeckAutoRotAngleMax);
        }

        public void InitStorables_StepCycle()
        {
            /* Step Cycle */

            js_StepsDelay = new JSONStorableFloat("Steps Delay", 0f, -1, 1, false);
            js_StepsDuration = new JSONStorableFloat("Steps Duration", 0.7f, 0.1f, 5f);
            js_StepsXOffset = new JSONStorableFloat("Feet Distance", 0.06f, -0.25f, 1f);
            js_StepsXOffsetIdle = new JSONStorableFloat("Feet Distance Idle", 0.15f, 0f, 1f);
            js_StepsYOffset = new JSONStorableFloat("Ground Offset", 0.05f, 0f, 1f, false);

            js_DurationRandom_Min = new JSONStorableFloat("Duration Random Min", 0f, -0.5f, 0f);
            js_DurationRandom_Max = new JSONStorableFloat("Duration Random Max", 0f, 0, 0.5f);

            js_XOffsetRandom_Min = new JSONStorableFloat("Feet Distance Random Min", 0f, -0.5f, 0f);
            js_XOffsetRandom_Max = new JSONStorableFloat("Feet Distance Random Max", 0f, 0, 0.5f);


            js_StepsDelay.setCallbackFunction = Callback_UpdateStepCycleParameters;
            js_StepsDuration.setCallbackFunction = Callback_UpdateStepCycleParameters;
            js_StepsXOffset.setCallbackFunction = Callback_UpdateStepCycleParameters;
            js_StepsXOffsetIdle.setCallbackFunction = Callback_UpdateStepCycleParameters;
            js_StepsYOffset.setCallbackFunction = Callback_UpdateStepCycleParameters;

            js_DurationRandom_Min.setCallbackFunction = Callback_UpdateStepCycleParameters;
            js_DurationRandom_Max.setCallbackFunction = Callback_UpdateStepCycleParameters;
            js_XOffsetRandom_Min.setCallbackFunction = Callback_UpdateStepCycleParameters;
            js_XOffsetRandom_Max.setCallbackFunction = Callback_UpdateStepCycleParameters;

            manager.RegisterFloat(js_StepsDelay);
            manager.RegisterFloat(js_StepsDuration);
            manager.RegisterFloat(js_StepsXOffset);
            manager.RegisterFloat(js_StepsXOffsetIdle);
            manager.RegisterFloat(js_StepsYOffset);

            manager.RegisterFloat(js_DurationRandom_Min);
            manager.RegisterFloat(js_DurationRandom_Max);
            manager.RegisterFloat(js_XOffsetRandom_Min);
            manager.RegisterFloat(js_XOffsetRandom_Max);
        }

        public void InitStorables_Feet()
        {
            /* Left Foot */

            js_LFootSide = new JSONStorableFloat("LeftFootSide", 0f, -0.5f, 0.5f, false);
            js_LFootUpDown = new JSONStorableFloat("LeftFootUpDown", 0f, -0.5f, 0.5f, false);
            js_LFootForward = new JSONStorableFloat("LeftFootForward", 0f, -0.5f, 0.5f, false);

            js_LFootYaw = new JSONStorableFloat("LeftFootYaw", 0f, -180f, 180f);
            js_LFootPitch = new JSONStorableFloat("LeftFootPitch", 25f, -180f, 180f);
            js_LFootRoll = new JSONStorableFloat("LeftFootRoll", 0f, -180f, 180f);

            js_LFootStepSide = new JSONStorableFloat("Step_LeftFootSide", 0.05f, -0.5f, 0.5f, false);
            js_LFootStepUpDown = new JSONStorableFloat("Step_LeftFootUpDown", 0.25f, -0.5f, 0.5f, false);
            js_LFootStepForward = new JSONStorableFloat("Step_LeftFootForward", 0f, -0.5f, 0.5f, false);

            js_LFootStepYaw = new JSONStorableFloat("Step_LeftFootYaw", 0f, -180f, 180f);
            js_LFootStepPitch = new JSONStorableFloat("Step_LeftFootPitch", 25f, -180f, 180f);
            js_LFootStepRoll = new JSONStorableFloat("Step_LeftFootRoll", 0f, -180f, 180f);

            js_Step_LeftFoot_MidPoint = new JSONStorableFloat("StepCurve_LeftFoot_MidPoint", 0.5f, 0.1f, 0.9f);
            js_Step_LeftFoot_Sharpness = new JSONStorableFloat("StepCurve_LeftFoot_Sharpness", 0.5f, 0.1f, 0.9f);

            manager.RegisterFloat(js_LFootSide);
            manager.RegisterFloat(js_LFootUpDown);
            manager.RegisterFloat(js_LFootForward);
            manager.RegisterFloat(js_LFootYaw);
            manager.RegisterFloat(js_LFootPitch);
            manager.RegisterFloat(js_LFootRoll);
            manager.RegisterFloat(js_LFootStepSide);
            manager.RegisterFloat(js_LFootStepUpDown);
            manager.RegisterFloat(js_LFootStepForward);
            manager.RegisterFloat(js_LFootStepYaw);
            manager.RegisterFloat(js_LFootStepPitch);
            manager.RegisterFloat(js_LFootStepRoll);
            manager.RegisterFloat(js_Step_LeftFoot_MidPoint);
            manager.RegisterFloat(js_Step_LeftFoot_Sharpness);

            /* Right Foot */

            js_RFootSide = new JSONStorableFloat("RightFootSide", 0f, -0.5f, 0.5f, false);
            js_RFootUpDown = new JSONStorableFloat("RightFootUpDown", 0f, -0.5f, 0.5f, false);
            js_RFootForward = new JSONStorableFloat("RightFootForward", 0f, -0.5f, 0.5f, false);

            js_RFootYaw = new JSONStorableFloat("RightFootYaw", 0f, -180f, 180f);
            js_RFootPitch = new JSONStorableFloat("RightFootPitch", 25f, -180f, 180f);
            js_RFootRoll = new JSONStorableFloat("RightFootRoll", 0f, -180f, 180f);

            js_RFootStepSide = new JSONStorableFloat("Step_RightFootSide", 0.05f, -0.5f, 0.5f, false);
            js_RFootStepUpDown = new JSONStorableFloat("Step_RightFootUpDown", 0.25f, -0.5f, 0.5f, false);
            js_RFootStepForward = new JSONStorableFloat("Step_RightFootForward", 0f, -0.5f, 0.5f, false);

            js_RFootStepYaw = new JSONStorableFloat("Step_RightFootYaw", 0, -180f, 180f);
            js_RFootStepPitch = new JSONStorableFloat("Step_RightFootPitch", 25, -180f, 180f);
            js_RFootStepRoll = new JSONStorableFloat("Step_RightFootRoll", 0, -180f, 180f);

            js_Step_RightFoot_MidPoint = new JSONStorableFloat("StepCurve_RightFoot_MidPoint", 0.5f, 0.1f, 0.9f);
            js_Step_RightFoot_Sharpness = new JSONStorableFloat("StepCurve_RightFoot_Sharpness", 0.5f, 0.1f, 0.9f);

            manager.RegisterFloat(js_RFootSide);
            manager.RegisterFloat(js_RFootUpDown);
            manager.RegisterFloat(js_RFootForward);
            manager.RegisterFloat(js_RFootYaw);
            manager.RegisterFloat(js_RFootPitch);
            manager.RegisterFloat(js_RFootRoll);
            manager.RegisterFloat(js_RFootStepSide);
            manager.RegisterFloat(js_RFootStepUpDown);
            manager.RegisterFloat(js_RFootStepForward);
            manager.RegisterFloat(js_RFootStepYaw);
            manager.RegisterFloat(js_RFootStepPitch);
            manager.RegisterFloat(js_RFootStepRoll);
            manager.RegisterFloat(js_Step_RightFoot_MidPoint);
            manager.RegisterFloat(js_Step_RightFoot_Sharpness);
        }

        public void InitStorables_Hips()
        {
            /* Hips */

            js_HipsSide = new JSONStorableFloat("HipsSide", 0, -0.5f, 0.5f, false);
            js_HipsUpDown = new JSONStorableFloat("HipsUpDown", -0.05f, -0.5f, 0.5f, false);
            js_HipsForward = new JSONStorableFloat("HipsForward", 0, -0.5f, 0.5f, false);
            js_HipsYaw = new JSONStorableFloat("HipsYaw", 0f, -180f, 180f);
            js_HipsPitch = new JSONStorableFloat("HipsPitch", -15f, -180f, 180f);
            js_HipsRoll = new JSONStorableFloat("HipsRoll", 0f, -180f, 180f);
            js_HipsStepSide = new JSONStorableFloat("Step_HipsSide", -0.03f, -0.5f, 0.5f, false);
            js_HipsStepUpDown = new JSONStorableFloat("Step_HipsUpDown", -0.05f, -0.5f, 0.5f, false);
            js_HipsStepForward = new JSONStorableFloat("Step_HipsForward", -0.05f, -0.5f, 0.5f, false);
            js_HipsStepYaw = new JSONStorableFloat("Step_HipsYaw", -10f, -180f, 180f);
            js_HipsStepPitch = new JSONStorableFloat("Step_HipsPitch", -15f, -180f, 180f);
            js_HipsStepRoll = new JSONStorableFloat("Step_HipsRoll", -25f, -180f, 180f);

            js_Step_Hips_MidPoint = new JSONStorableFloat("StepCurve_Hips_MidPoint", 0.5f, 0.1f, 0.9f);
            js_Step_Hips_Sharpness = new JSONStorableFloat("StepCurve_Hips_Sharpness", 0.5f, 0.1f, 0.9f);

            manager.RegisterFloat(js_HipsSide);
            manager.RegisterFloat(js_HipsUpDown);
            manager.RegisterFloat(js_HipsForward);
            manager.RegisterFloat(js_HipsYaw);
            manager.RegisterFloat(js_HipsPitch);
            manager.RegisterFloat(js_HipsRoll);
            manager.RegisterFloat(js_HipsStepSide);
            manager.RegisterFloat(js_HipsStepUpDown);
            manager.RegisterFloat(js_HipsStepForward);
            manager.RegisterFloat(js_HipsStepYaw);
            manager.RegisterFloat(js_HipsStepPitch);
            manager.RegisterFloat(js_HipsStepRoll);
            manager.RegisterFloat(js_Step_Hips_MidPoint);
            manager.RegisterFloat(js_Step_Hips_Sharpness);
        }

        public void InitStorables_Chest()
        {
            /* Chest */

            js_ChestSide = new JSONStorableFloat("ChestSide", 0f, -0.5f, 0.5f, false);
            js_ChestUpDown = new JSONStorableFloat("ChestUpDown", 0f, -0.5f, 0.5f, false);
            js_ChestForward = new JSONStorableFloat("ChestForward", 0.05f, -0.5f, 0.5f, false);
            js_ChestYaw = new JSONStorableFloat("ChestYaw", 0, -180f, 180f);
            js_ChestPitch = new JSONStorableFloat("ChestPitch", 0, -180f, 180f);
            js_ChestRoll = new JSONStorableFloat("ChestRoll", 0, -180f, 180f);
            js_ChestStepSide = new JSONStorableFloat("Step_ChestSide", 0.05f, -0.5f, 0.5f, false);
            js_ChestStepUpDown = new JSONStorableFloat("Step_ChestUpDown", -0.02f, -0.5f, 0.5f, false);
            js_ChestStepForward = new JSONStorableFloat("Step_ChestForward", 0f, -0.5f, 0.5f, false);
            js_ChestStepYaw = new JSONStorableFloat("Step_ChestYaw", 15f, -180f, 180f);
            js_ChestStepPitch = new JSONStorableFloat("Step_ChestPitch", 0f, -180f, 180f);
            js_ChestStepRoll = new JSONStorableFloat("Step_ChestRoll", 15f, -180f, 180f);

            js_Step_Chest_MidPoint = new JSONStorableFloat("StepCurve_Chest_MidPoint", 0.5f, 0.1f, 0.9f);
            js_Step_Chest_Sharpness = new JSONStorableFloat("StepCurve_Chest_Sharpness", 0.5f, 0.1f, 0.9f);

            manager.RegisterFloat(js_ChestSide);
            manager.RegisterFloat(js_ChestUpDown);
            manager.RegisterFloat(js_ChestForward);
            manager.RegisterFloat(js_ChestYaw);
            manager.RegisterFloat(js_ChestPitch);
            manager.RegisterFloat(js_ChestRoll);
            manager.RegisterFloat(js_ChestStepSide);
            manager.RegisterFloat(js_ChestStepUpDown);
            manager.RegisterFloat(js_ChestStepForward);
            manager.RegisterFloat(js_ChestForward);
            manager.RegisterFloat(js_ChestStepYaw);
            manager.RegisterFloat(js_ChestStepPitch);
            manager.RegisterFloat(js_ChestStepRoll);
            manager.RegisterFloat(js_Step_Chest_MidPoint);
            manager.RegisterFloat(js_Step_Chest_Sharpness);
        }

        public void InitStorables_Neck()
        {
            /* Neck */

            js_NeckSide = new JSONStorableFloat("NeckSide", 0f, -0.5f, 0.5f, false);
            js_NeckUpDown = new JSONStorableFloat("NeckUpDown", 0f, -0.5f, 0.5f, false);
            js_NeckForward = new JSONStorableFloat("NeckForward", -0.05f, -0.5f, 0.5f, false);
            js_NeckYaw = new JSONStorableFloat("NeckYaw", 0f, -180f, 180f);
            js_NeckPitch = new JSONStorableFloat("NeckPitch", 15f, -180f, 180f);
            js_NeckRoll = new JSONStorableFloat("NeckRoll", 0f, -180f, 180f);
            js_NeckStepSide = new JSONStorableFloat("Step_NeckSide", 0f, -0.5f, 0.5f, false);
            js_NeckStepUpDown = new JSONStorableFloat("Step_NeckUpDown", -0.05f, -0.3f, 0.3f, false);
            js_NeckStepForward = new JSONStorableFloat("Step_NeckForward", 0f, -0.5f, 0.5f, false);
            js_NeckStepYaw = new JSONStorableFloat("Step_NeckYaw", 0f, -180f, 180f);
            js_NeckStepPitch = new JSONStorableFloat("Step_NeckPitch", 0f, -180f, 180f);
            js_NeckStepRoll = new JSONStorableFloat("Step_NeckRoll", 0f, -180f, 180f);

            js_Step_Neck_MidPoint = new JSONStorableFloat("StepCurve_Neck_MidPoint", 0.5f, 0.1f, 0.9f);
            js_Step_Neck_Sharpness = new JSONStorableFloat("StepCurve_Neck_Sharpness", 0.5f, 0.1f, 0.9f);

            manager.RegisterFloat(js_NeckSide);
            manager.RegisterFloat(js_NeckUpDown);
            manager.RegisterFloat(js_NeckForward);
            manager.RegisterFloat(js_NeckYaw);
            manager.RegisterFloat(js_NeckPitch);
            manager.RegisterFloat(js_NeckRoll);
            manager.RegisterFloat(js_NeckStepSide);
            manager.RegisterFloat(js_NeckStepUpDown);
            manager.RegisterFloat(js_NeckStepForward);
            manager.RegisterFloat(js_NeckForward);
            manager.RegisterFloat(js_NeckStepYaw);
            manager.RegisterFloat(js_NeckStepPitch);
            manager.RegisterFloat(js_NeckStepRoll);
            manager.RegisterFloat(js_Step_Neck_MidPoint);
            manager.RegisterFloat(js_Step_Neck_Sharpness);
        }

        public void InitStorables_Knees()
        {
            /* Left Knee */

            js_LKneeSide = new JSONStorableFloat("LeftKneeSide", 0.05f, -0.5f, 0.5f, false);
            js_LKneeUpDown = new JSONStorableFloat("LeftKneeUpDown", 0f, -0.5f, 0.5f, false);
            js_LKneeForward = new JSONStorableFloat("LeftKneeForward", 0.07f, -0.5f, 0.5f, false);
            js_LKneeStepSide = new JSONStorableFloat("Step_LeftKneeSide", -0.02f, -0.5f, 0.5f);
            js_LKneeStepUpDown = new JSONStorableFloat("Step_LeftKneeUpDown", -0.15f, -0.5f, 0.5f);
            js_LKneeStepForward = new JSONStorableFloat("Step_LeftKneeForward", 0.2f, -0.5f, 0.5f);

            js_Step_LeftKnee_MidPoint = new JSONStorableFloat("StepCurve_LeftKnee_MidPoint", 0.5f, 0.1f, 0.9f);
            js_Step_LeftKnee_Sharpness = new JSONStorableFloat("StepCurve_LeftKnee_Sharpness", 0.5f, 0.1f, 0.9f);

            manager.RegisterFloat(js_LKneeSide);
            manager.RegisterFloat(js_LKneeUpDown);
            manager.RegisterFloat(js_LKneeForward);
            manager.RegisterFloat(js_LKneeStepSide);
            manager.RegisterFloat(js_LKneeStepUpDown);
            manager.RegisterFloat(js_LKneeStepForward);

            manager.RegisterFloat(js_Step_LeftKnee_MidPoint);
            manager.RegisterFloat(js_Step_LeftKnee_Sharpness);

            /* Right Knee */

            js_RKneeSide = new JSONStorableFloat("RightKneeSide", 0.05f, -0.5f, 0.5f, false);
            js_RKneeUpDown = new JSONStorableFloat("RightKneeUpDown", 0f, -0.5f, 0.5f, false);
            js_RKneeForward = new JSONStorableFloat("RightKneeForward", 0.07f, -0.5f, 0.5f, false);
            js_RKneeStepSide = new JSONStorableFloat("Step_RightKneeSide", -0.02f, -0.5f, 0.5f);
            js_RKneeStepUpDown = new JSONStorableFloat("Step_RightKneeUpDown", -0.15f, -0.5f, 0.5f);
            js_RKneeStepForward = new JSONStorableFloat("Step_RightKneeForward", 0.2f, -0.5f, 0.5f);

            js_Step_RightKnee_MidPoint = new JSONStorableFloat("StepCurve_RightKnee_MidPoint", 0.5f, 0.1f, 0.9f);
            js_Step_RightKnee_Sharpness = new JSONStorableFloat("StepCurve_RightKnee_Sharpness", 0.5f, 0.1f, 0.9f);

            manager.RegisterFloat(js_RKneeSide);
            manager.RegisterFloat(js_RKneeUpDown);
            manager.RegisterFloat(js_RKneeForward);
            manager.RegisterFloat(js_RKneeStepSide);
            manager.RegisterFloat(js_RKneeStepUpDown);
            manager.RegisterFloat(js_RKneeStepForward);

            manager.RegisterFloat(js_Step_RightKnee_MidPoint);
            manager.RegisterFloat(js_Step_RightKnee_Sharpness);
        }

        public void InitStorables_Arms()
        {
            /* Left Arm */

            js_LShoulderSide = new JSONStorableFloat("LeftShoulderSide", 0.13f, -0.5f, 0.5f);
            js_LShoulderUpDown = new JSONStorableFloat("LeftShoulderUpDown", 0.15f, -0.5f, 0.5f);
            js_LShoulderForward = new JSONStorableFloat("LeftShoulderForward", -0.08f, -0.5f, 0.5f);
            js_LHandSide = new JSONStorableFloat("LeftHandSide", 0.25f, -1f, 1f);
            js_LHandUpDown = new JSONStorableFloat("LeftHandUpDown", -0.31f, -1f, 1f);
            js_LHandForward = new JSONStorableFloat("LeftHandForward", -0.03f, -1f, 1f);
            js_LHandYaw = new JSONStorableFloat("LeftHandYaw", 0f, -180f, 180f);
            js_LHandPitch = new JSONStorableFloat("LeftHandPitch", -20f, -180f, 180f);
            js_LHandRoll = new JSONStorableFloat("LeftHandRoll", 45f, -180f, 180f);
            js_LElbowSide = new JSONStorableFloat("LeftElbowSide", -0.06f, -0.5f, 0.5f);
            js_LElbowUpDown = new JSONStorableFloat("LeftElbowUpDown", -0.03f, -0.5f, 0.5f);
            js_LElbowForward = new JSONStorableFloat("LeftElbowForward", 0, -0.5f, 0.5f);
            js_LShoulderStepSide = new JSONStorableFloat("Step_LeftShoulderSide", 0.05f, -0.5f, 0.5f);
            js_LShoulderStepUpDown = new JSONStorableFloat("Step_LeftShoulderUpDown", 0.03f, -0.5f, 0.5f);
            js_LShoulderStepForward = new JSONStorableFloat("Step_LeftShoulderForward", 0f, -0.5f, 0.5f);
            js_LHandStepSide = new JSONStorableFloat("Step_LeftHandSide", 0.03f, -1f, 1f);
            js_LHandStepUpDown = new JSONStorableFloat("Step_LeftHandUpDown", 0f, -1f, 1f);
            js_LHandStepForward = new JSONStorableFloat("Step_LeftHandForward", -0.10f, -1f, 1f);
            js_LHandStepYaw = new JSONStorableFloat("Step_LeftHandYaw", 15f, -180f, 180f);
            js_LHandStepPitch = new JSONStorableFloat("Step_LeftHandPitch", 0f, -180f, 180f);
            js_LHandStepRoll = new JSONStorableFloat("Step_LeftHandRoll", 0f, -180f, 180f);
            js_LElbowStepSide = new JSONStorableFloat("Step_LeftElbowSide", 0, -0.5f, 0.5f);
            js_LElbowStepUpDown = new JSONStorableFloat("Step_LeftElbowUpDown", 0, -0.5f, 0.5f);
            js_LElbowStepForward = new JSONStorableFloat("Step_LeftElbowForward", 0, -0.5f, 0.5f);

            js_Step_RightShoulder_MidPoint = new JSONStorableFloat("StepCurve_RightShoulder_MidPoint", 0.5f, 0.1f, 0.9f);
            js_Step_RightShoulder_Sharpness = new JSONStorableFloat("StepCurve_RightShoulder_Sharpness", 0.5f, 0.1f, 0.9f);
            js_Step_RightElbow_MidPoint = new JSONStorableFloat("StepCurve_RightElbow_MidPoint", 0.5f, 0.1f, 0.9f);
            js_Step_RightElbow_Sharpness = new JSONStorableFloat("StepCurve_RightElbow_Sharpness", 0.5f, 0.1f, 0.9f);
            js_Step_RightHand_MidPoint = new JSONStorableFloat("StepCurve_RightHand_MidPoint", 0.5f, 0.1f, 0.9f);
            js_Step_RightHand_Sharpness = new JSONStorableFloat("StepCurve_RightHand_Sharpness", 0.5f, 0.1f, 0.9f);


            manager.RegisterFloat(js_LShoulderSide);
            manager.RegisterFloat(js_LShoulderUpDown);
            manager.RegisterFloat(js_LShoulderForward);
            manager.RegisterFloat(js_LHandSide);
            manager.RegisterFloat(js_LHandUpDown);
            manager.RegisterFloat(js_LHandForward);
            manager.RegisterFloat(js_LHandYaw);
            manager.RegisterFloat(js_LHandPitch);
            manager.RegisterFloat(js_LHandRoll);
            manager.RegisterFloat(js_LElbowSide);
            manager.RegisterFloat(js_LElbowUpDown);
            manager.RegisterFloat(js_LElbowForward);
            manager.RegisterFloat(js_LShoulderStepSide);
            manager.RegisterFloat(js_LShoulderStepUpDown);
            manager.RegisterFloat(js_LShoulderStepForward);
            manager.RegisterFloat(js_LHandStepSide);
            manager.RegisterFloat(js_LHandStepUpDown);
            manager.RegisterFloat(js_LHandStepForward);
            manager.RegisterFloat(js_LHandStepYaw);
            manager.RegisterFloat(js_LHandStepPitch);
            manager.RegisterFloat(js_LHandStepRoll);
            manager.RegisterFloat(js_LElbowStepSide);
            manager.RegisterFloat(js_LElbowStepUpDown);
            manager.RegisterFloat(js_LElbowStepForward);

            manager.RegisterFloat(js_Step_RightShoulder_MidPoint);
            manager.RegisterFloat(js_Step_RightShoulder_Sharpness);
            manager.RegisterFloat(js_Step_RightElbow_MidPoint);
            manager.RegisterFloat(js_Step_RightElbow_Sharpness);
            manager.RegisterFloat(js_Step_RightHand_MidPoint);
            manager.RegisterFloat(js_Step_RightHand_Sharpness);

            /* Right Arm */

            js_RShoulderSide = new JSONStorableFloat("RightShoulderSide", 0.13f, -0.5f, 0.5f);
            js_RShoulderUpDown = new JSONStorableFloat("RightShoulderUpDown", 0.15f, -0.5f, 0.5f);
            js_RShoulderForward = new JSONStorableFloat("RightShoulderForward", -0.08f, -0.5f, 0.5f);
            js_RHandSide = new JSONStorableFloat("RightHandSide", 0.25f, -1f, 1f);
            js_RHandUpDown = new JSONStorableFloat("RightHandUpDown", -0.31f, -1f, 1f);
            js_RHandForward = new JSONStorableFloat("RightHandForward", -0.03f, -1f, 1f);
            js_RHandYaw = new JSONStorableFloat("RightHandYaw", 0f, -180f, 180f);
            js_RHandPitch = new JSONStorableFloat("RightHandPitch", -20f, -180f, 180f);
            js_RHandRoll = new JSONStorableFloat("RightHandRoll", 45f, -180f, 180f);
            js_RElbowSide = new JSONStorableFloat("RightElbowSide", -0.06f, -0.5f, 0.5f);
            js_RElbowUpDown = new JSONStorableFloat("RightElbowUpDown", -0.03f, -0.5f, 0.5f);
            js_RElbowForward = new JSONStorableFloat("RightElbowForward", 0, -0.5f, 0.5f);
            js_RShoulderStepSide = new JSONStorableFloat("Step_RightShoulderSide", 0.05f, -0.5f, 0.5f);
            js_RShoulderStepUpDown = new JSONStorableFloat("Step_RightShoulderUpDown", -0.03f, -0.5f, 0.5f);
            js_RShoulderStepForward = new JSONStorableFloat("Step_RightShoulderForward", 0f, -0.5f, 0.5f);
            js_RHandStepSide = new JSONStorableFloat("Step_RightHandSide", -0.03f, -1f, 1f);
            js_RHandStepUpDown = new JSONStorableFloat("Step_RightHandUpDown", 0f, -1f, 1f);
            js_RHandStepForward = new JSONStorableFloat("Step_RightHandForward", 0.1f, -1f, 1f);
            js_RHandStepYaw = new JSONStorableFloat("Step_RightHandYaw", -15f, -180f, 180f);
            js_RHandStepPitch = new JSONStorableFloat("Step_RightHandPitch", 0f, -180f, 180f);
            js_RHandStepRoll = new JSONStorableFloat("Step_RightHandRoll", 0f, -180f, 180f);
            js_RElbowStepSide = new JSONStorableFloat("Step_RightElbowSide", 0, -0.5f, 0.5f);
            js_RElbowStepUpDown = new JSONStorableFloat("Step_RightElbowUpDown", 0, -0.5f, 0.5f);
            js_RElbowStepForward = new JSONStorableFloat("Step_RightElbowForward", 0, -0.5f, 0.5f);

            js_Step_LeftShoulder_MidPoint = new JSONStorableFloat("StepCurve_LeftShoulder_MidPoint", 0.5f, 0.1f, 0.9f);
            js_Step_LeftShoulder_Sharpness = new JSONStorableFloat("StepCurve_LeftShoulder_Sharpness", 0.5f, 0.1f, 0.9f);
            js_Step_LeftElbow_MidPoint = new JSONStorableFloat("StepCurve_LeftElbow_MidPoint", 0.5f, 0.1f, 0.9f);
            js_Step_LeftElbow_Sharpness = new JSONStorableFloat("StepCurve_LeftElbow_Sharpness", 0.5f, 0.1f, 0.9f);
            js_Step_LeftHand_MidPoint = new JSONStorableFloat("StepCurve_LeftHand_MidPoint", 0.5f, 0.1f, 0.9f);
            js_Step_LeftHand_Sharpness = new JSONStorableFloat("StepCurve_LeftHand_Sharpness", 0.5f, 0.1f, 0.9f);


            manager.RegisterFloat(js_RShoulderSide);
            manager.RegisterFloat(js_RShoulderUpDown);
            manager.RegisterFloat(js_RShoulderForward);
            manager.RegisterFloat(js_RHandSide);
            manager.RegisterFloat(js_RHandUpDown);
            manager.RegisterFloat(js_RHandForward);
            manager.RegisterFloat(js_RHandYaw);
            manager.RegisterFloat(js_RHandPitch);
            manager.RegisterFloat(js_RHandRoll);
            manager.RegisterFloat(js_RElbowSide);
            manager.RegisterFloat(js_RElbowUpDown);
            manager.RegisterFloat(js_RElbowForward);
            manager.RegisterFloat(js_RShoulderStepSide);
            manager.RegisterFloat(js_RShoulderStepUpDown);
            manager.RegisterFloat(js_RShoulderStepForward);
            manager.RegisterFloat(js_RHandStepSide);
            manager.RegisterFloat(js_RHandStepUpDown);
            manager.RegisterFloat(js_RHandStepForward);
            manager.RegisterFloat(js_RHandStepYaw);
            manager.RegisterFloat(js_RHandStepPitch);
            manager.RegisterFloat(js_RHandStepRoll);
            manager.RegisterFloat(js_RElbowStepSide);
            manager.RegisterFloat(js_RElbowStepUpDown);
            manager.RegisterFloat(js_RElbowStepForward);

            manager.RegisterFloat(js_Step_LeftShoulder_MidPoint);
            manager.RegisterFloat(js_Step_LeftShoulder_Sharpness);
            manager.RegisterFloat(js_Step_LeftElbow_MidPoint);
            manager.RegisterFloat(js_Step_LeftElbow_Sharpness);
            manager.RegisterFloat(js_Step_LeftHand_MidPoint);
            manager.RegisterFloat(js_Step_LeftHand_Sharpness);
        }

        protected void CreateStepCycle()
        {
            /* Back Step Cycle */

            stepCycle = new StepCycle(manager);

            List<Step> _steps = new List<Step>();

            _steps.Add(new Step(stepCycle, js_StepsDuration.val, js_StepsDelay.val, true));
            _steps.Add(new Step(stepCycle, js_StepsDuration.val, js_StepsDelay.val, false));

            stepCycle.SetSteps(_steps);

            /* Front Step Cycle */

            Callback_UpdateStepCycleParameters(0);
        }

        public override void Start()
        {
            stepCycle.Init();

            isActive = true;
        }

        #endregion

        #region BodyController Init

        public BodyController_Standing(CLS _manager) : base(_manager)
        {
            InitStorables();
            CreateJSONStorableLists();
            CreateStepCycle();

            UpdateBodyProportions();

            presetLoadStartData = new BodyControllerDataSet();
            presetLoadEndData = new BodyControllerDataSet();

            kneelingTransitionOffsetCurve = new AnimationCurve();
            kneelingTransitionOffsetCurve.AddKey(0, 0);
            kneelingTransitionOffsetCurve.AddKey(0.5f, 1);
            kneelingTransitionOffsetCurve.AddKey(1, 0);


            /* Events callbacks*/

            stepCycle.idleStateDelegate += Event_StartStepIdle;

            headControl.onGrabStartHandlers += Callback_OnHeadGrab;
            headControl.onGrabEndHandlers += Callback_OnHeadRelease;
        }

        public override bool IsStanding
        {
            get
            {
                return js_Standing.val;
            }
        }

        public override void Update()
        {
            base.Update();

            try
            {
                UpdatePresetTransition();               
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        public override void OnDestroy()
        {
            base.OnDestroy();

            headControl.onGrabStartHandlers -= Callback_OnHeadGrab;
            headControl.onGrabEndHandlers -= Callback_OnHeadRelease;
        }

        #endregion

        #region Body Control System

        /* Control Target Functions */

        protected float rStepStr;
        protected float lStepStr;
        protected Vector3 baseBodyPos;
        protected Vector3 baseChestPos;
        protected Quaternion baseChestRot;
        protected Quaternion baseHipsRot;
        protected Quaternion baseBodyRot;
        protected float kneesBodyHeightFactor;
        protected float shinLength;
        protected float thighLength;
        protected float armLength;
        protected float forearmLength;
        protected float effectiveBodyHeight = 1;

        protected bool bKneelingTransition;
        protected float kneelingTransitionStartTime;
        protected float kneelingTransitionDuration = 1f;
        protected float kneelingTransitionTimeLeft = 0;
        protected float kneelingTransitionTimeRight = 0;

        protected AnimationCurve kneelingTransitionOffsetCurve;
        protected Vector3 kneelingTransitionFootOffset = new Vector3(0, 0.15f, 0);

        protected override void UpdateTargets()
        {
            if (!isActive)
                return;

            if(js_AutoAdaptHeight.val)
            {
                effectiveBodyHeight = Mathf.Clamp01(manager.GetTargetBodyHeight);
            }
            else
            {
                effectiveBodyHeight = js_BodyHeight.val;
            }

            kneesBodyHeightFactor = Mathf.Clamp01(1 - js_BodyHeight.val) * 0.5f;

            try
            {
                UpdateDanceMode();

                UpdateLegsTargets();
                UpdateHipsTarget();
                UpdateChestTarget();
                UpdateNeckTarget();                
                UpdateLeftArmTarget();
                UpdateRightArmTarget();               
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        protected void UpdateLegsTargets()
        {
            if (!bKneelingTransition)
            {
                if (js_SwitchStanceAuto.val)
                {
                    if ((effectiveBodyHeight < 0.45f && js_Standing.val) || (effectiveBodyHeight > 0.45f && !js_Standing.val))
                    {
                        bKneelingTransition = true;
                        kneelingTransitionStartTime = Time.time;

                        js_Standing.val = !js_Standing.val;

                        manager.LockMovement();

                        if(js_Standing.val)
                            manager.trigger_OnStanding.Trigger();
                        else
                            manager.trigger_OnKneeling.Trigger();
                    }
                }
            }
            else
            {
                if (Time.time - kneelingTransitionStartTime > kneelingTransitionDuration)
                {
                    bKneelingTransition = false;

                    manager.UnlockMovement();
                }
            }


            if (bKneelingTransition)
            {
                kneelingTransitionTimeRight = Mathf.Clamp01((Time.time - kneelingTransitionStartTime) / (kneelingTransitionDuration / 2));
                kneelingTransitionTimeLeft = Mathf.Clamp01((Time.time - (kneelingTransitionStartTime + (kneelingTransitionDuration / 2))) / (kneelingTransitionDuration / 2));

                if (js_Standing.val)
                {
                    lFootTargetPos = Vector3.Lerp(ComputeLFootPos_Kneeling(), ComputeLFootPos_Standing(), kneelingTransitionTimeLeft);
                    lFootTargetPos += kneelingTransitionFootOffset * kneelingTransitionOffsetCurve.Evaluate(kneelingTransitionTimeLeft);

                    lFootTargetRot = Quaternion.Lerp(ComputeLFootRot_Kneeling(), ComputeLFootRot_Standing(), kneelingTransitionTimeLeft);

                    rFootTargetPos = Vector3.Lerp(ComputeRFootPos_Kneeling(), ComputeRFootPos_Standing(), kneelingTransitionTimeRight);
                    rFootTargetPos += kneelingTransitionFootOffset * kneelingTransitionOffsetCurve.Evaluate(kneelingTransitionTimeRight);

                    rFootTargetRot = Quaternion.Lerp(ComputeRFootRot_Kneeling(), ComputeRFootRot_Standing(), kneelingTransitionTimeRight);

                    lKneeTargetPos = Vector3.Lerp(ComputeLKneePos_Kneeling(), ComputeLKneePos_Standing(), kneelingTransitionTimeLeft);
                    rKneeTargetPos = Vector3.Lerp(ComputeRKneePos_Kneeling(), ComputeRKneePos_Standing(), kneelingTransitionTimeRight);
                }
                else
                {
                    lFootTargetPos = Vector3.Lerp(ComputeLFootPos_Standing(), ComputeLFootPos_Kneeling(), kneelingTransitionTimeLeft);
                    lFootTargetPos += kneelingTransitionFootOffset * kneelingTransitionOffsetCurve.Evaluate(kneelingTransitionTimeLeft);

                    lFootTargetRot = Quaternion.Lerp(ComputeLFootRot_Standing(), ComputeLFootRot_Kneeling(), kneelingTransitionTimeLeft);

                    rFootTargetPos = Vector3.Lerp(ComputeRFootPos_Standing(), ComputeRFootPos_Kneeling(), kneelingTransitionTimeRight);
                    rFootTargetPos += kneelingTransitionFootOffset * kneelingTransitionOffsetCurve.Evaluate(kneelingTransitionTimeRight);

                    rFootTargetRot = Quaternion.Lerp(ComputeRFootRot_Standing(), ComputeRFootRot_Kneeling(), kneelingTransitionTimeRight);

                    lKneeTargetPos = Vector3.Lerp(ComputeLKneePos_Standing(), ComputeLKneePos_Kneeling(), kneelingTransitionTimeLeft);
                    rKneeTargetPos = Vector3.Lerp(ComputeRKneePos_Standing(), ComputeRKneePos_Kneeling(), kneelingTransitionTimeRight);
                }
            }
            else
            {
                if (js_Standing.val)
                {
                    lFootTargetPos = ComputeLFootPos_Standing();
                    lFootTargetRot = ComputeLFootRot_Standing();

                    rFootTargetPos = ComputeRFootPos_Standing();
                    rFootTargetRot = ComputeRFootRot_Standing();

                    lKneeTargetPos = ComputeLKneePos_Standing();
                    rKneeTargetPos = ComputeRKneePos_Standing();
                }
                else
                {
                    lFootTargetPos = ComputeLFootPos_Kneeling();
                    lFootTargetRot = ComputeLFootRot_Kneeling();

                    rFootTargetPos = ComputeRFootPos_Kneeling();
                    rFootTargetRot = ComputeRFootRot_Kneeling();

                    lKneeTargetPos = ComputeLKneePos_Kneeling();
                    rKneeTargetPos = ComputeRKneePos_Kneeling();
                }
            }
        }

        protected void UpdateHipsTarget()
        {
            /* Hips */

            rStepStr = stepCycle.GetStep(0).GetStepStrength(js_Step_Hips_MidPoint.val, js_Step_Hips_Sharpness.val);
            lStepStr = stepCycle.GetStep(1).GetStepStrength(js_Step_Hips_MidPoint.val, js_Step_Hips_Sharpness.val);

            hipTargetPos = Vector3.Lerp(stepCycle.GetStep(0).TargetPos, stepCycle.GetStep(1).TargetPos, 0.5f);

            if (stepCycle.GetStep(0).TargetPos.y > stepCycle.GetStep(1).TargetPos.y)
                hipTargetPos.y = stepCycle.GetStep(1).TargetPos.y;
            else
                hipTargetPos.y = stepCycle.GetStep(0).TargetPos.y;

            hipTargetPos.y += effectiveBodyHeight;

            hipTargetPos.y += Mathf.Lerp(0, js_Step_BodyHeight.val, rStepStr);
            hipTargetPos.y += Mathf.Lerp(0, js_Step_BodyHeight.val, lStepStr);

            baseBodyPos = hipTargetPos;

            if(manager.UseTargetTransformRotation)
            {
                if (manager.RotationTargetAtom != null)
                {
                    hipTargetRot = manager.RotationTargetAtom.mainController.transform.rotation;
                }
                else
                    hipTargetRot = manager.TargetTransform.rotation;      
            }
            else
            {
                hipTargetRot = Quaternion.Lerp(stepCycle.GetStep(0).TargetRot, stepCycle.GetStep(1).TargetRot, 0.5f);
            }
           
            baseHipsRot = hipTargetRot;

            hipTargetRot *= Quaternion.AngleAxis(js_BodyPitch.val, Vector3.right);
            hipTargetRot *= Quaternion.AngleAxis(js_BodyYaw.val, Vector3.up);
            hipTargetRot *= Quaternion.AngleAxis(js_BodyRoll.val, Vector3.forward);

            hipTargetRot *= Quaternion.AngleAxis(js_Step_BodyPitch.val * rStepStr, Vector3.right);
            hipTargetRot *= Quaternion.AngleAxis(js_Step_BodyYaw.val * rStepStr, Vector3.up);
            hipTargetRot *= Quaternion.AngleAxis(js_Step_BodyRoll.val * rStepStr, Vector3.forward);

            hipTargetRot *= Quaternion.AngleAxis(js_Step_BodyPitch.val * lStepStr, Vector3.right);
            hipTargetRot *= Quaternion.AngleAxis(-js_Step_BodyYaw.val * lStepStr, Vector3.up);
            hipTargetRot *= Quaternion.AngleAxis(-js_Step_BodyRoll.val * lStepStr, Vector3.forward);

            hipTargetRot *= Quaternion.AngleAxis(hipsAutoRotCurrent, Vector3.up);

            baseBodyRot = hipTargetRot;

            hipTargetPos += baseHipsRot * new Vector3(js_HipsSide.val, js_HipsUpDown.val, js_HipsForward.val - Mathf.Clamp01(1 - effectiveBodyHeight / 1) * 0.5f);

            hipTargetPos += baseHipsRot * new Vector3(js_HipsStepSide.val, js_HipsStepUpDown.val, js_HipsStepForward.val) * rStepStr;
            hipTargetPos += baseHipsRot * new Vector3(-js_HipsStepSide.val, js_HipsStepUpDown.val, js_HipsStepForward.val) * lStepStr;

            hipTargetRot *= Quaternion.Euler(js_HipsPitch.val, js_HipsYaw.val, js_HipsRoll.val);

            hipTargetRot *= Quaternion.Euler(js_HipsStepPitch.val * rStepStr, js_HipsStepYaw.val * rStepStr, js_HipsStepRoll.val * rStepStr);
            hipTargetRot *= Quaternion.Euler(js_HipsStepPitch.val * lStepStr, -js_HipsStepYaw.val * lStepStr, -js_HipsStepRoll.val * lStepStr);
        }

        protected void UpdateChestTarget()
        {
            /* Chest */

            rStepStr = stepCycle.GetStep(0).GetStepStrength(js_Step_Chest_MidPoint.val, js_Step_Chest_Sharpness.val);
            lStepStr = stepCycle.GetStep(1).GetStepStrength(js_Step_Chest_MidPoint.val, js_Step_Chest_Sharpness.val);

            chestTargetPos = baseBodyPos;
            chestTargetPos += baseBodyRot * new Vector3(js_ChestSide.val, js_ChestUpDown.val + 0.3f, js_ChestForward.val);

            chestTargetPos += baseBodyRot * new Vector3(js_ChestStepSide.val, js_ChestStepUpDown.val, js_ChestStepForward.val) * rStepStr;
            chestTargetPos += baseBodyRot * new Vector3(-js_ChestStepSide.val, js_ChestStepUpDown.val, js_ChestStepForward.val) * lStepStr;

            baseChestPos = chestTargetPos;

            chestTargetRot = baseBodyRot;

            chestTargetRot *= Quaternion.Euler(js_ChestPitch.val, js_ChestYaw.val, js_ChestRoll.val);            

            baseChestRot = chestTargetRot;

            chestTargetRot *= Quaternion.AngleAxis(chestAutoRotCurrent, Vector3.up);

            chestTargetRot *= Quaternion.Euler(js_ChestStepPitch.val * rStepStr, js_ChestStepYaw.val * rStepStr, js_ChestStepRoll.val * rStepStr);
            chestTargetRot *= Quaternion.Euler(js_ChestStepPitch.val * lStepStr, -js_ChestStepYaw.val * lStepStr, -js_ChestStepRoll.val * lStepStr);
        }

        protected void UpdateNeckTarget()
        {
            /* Neck */

            rStepStr = stepCycle.GetStep(0).GetStepStrength(js_Step_Neck_MidPoint.val, js_Step_Neck_Sharpness.val);
            lStepStr = stepCycle.GetStep(1).GetStepStrength(js_Step_Neck_MidPoint.val, js_Step_Neck_Sharpness.val);

            neckTargetPos = baseChestPos;
            neckTargetPos += baseChestRot * new Vector3(js_NeckSide.val, js_NeckUpDown.val + 0.2f, js_NeckForward.val);

            neckTargetPos += baseChestRot * new Vector3(js_NeckStepSide.val, js_NeckStepUpDown.val, js_NeckStepForward.val) * rStepStr;
            neckTargetPos += baseChestRot * new Vector3(-js_NeckStepSide.val, js_NeckStepUpDown.val, js_NeckStepForward.val) * lStepStr;

            neckTargetRot = baseChestRot;

            neckTargetRot *= Quaternion.Euler(js_NeckPitch.val, js_NeckYaw.val, js_NeckRoll.val);
            neckTargetRot *= Quaternion.AngleAxis(neckAutoRotCurrent, Vector3.up);

            neckTargetRot *= Quaternion.Euler(js_NeckStepPitch.val * rStepStr, js_NeckStepYaw.val * rStepStr, js_NeckStepRoll.val * rStepStr);
            neckTargetRot *= Quaternion.Euler(js_NeckStepPitch.val * lStepStr, -js_NeckStepYaw.val * lStepStr, -js_NeckStepRoll.val * lStepStr);
        }

        protected void UpdateLeftArmTarget()
        {
            /* Left Shoulder */

            rStepStr = stepCycle.GetStep(0).GetStepStrength(js_Step_LeftShoulder_MidPoint.val, js_Step_LeftShoulder_Sharpness.val);
            lStepStr = stepCycle.GetStep(1).GetStepStrength(js_Step_LeftShoulder_MidPoint.val, js_Step_LeftShoulder_Sharpness.val);

            lShoulderTargetPos = baseChestPos + (baseBodyRot * new Vector3(-js_LShoulderSide.val, js_LShoulderUpDown.val, js_LShoulderForward.val));
            lShoulderTargetPos += baseBodyRot * new Vector3(js_LShoulderStepSide.val * lStepStr, js_LShoulderStepUpDown.val * lStepStr, js_LShoulderStepForward.val * lStepStr);
            lShoulderTargetPos += baseBodyRot * new Vector3(-js_LShoulderStepSide.val * rStepStr, -js_LShoulderStepUpDown.val * rStepStr, -js_LShoulderStepForward.val * rStepStr);


            /* Left Hand Pos*/

            rStepStr = stepCycle.GetStep(0).GetStepStrength(js_Step_LeftHand_MidPoint.val, js_Step_LeftHand_Sharpness.val);
            lStepStr = stepCycle.GetStep(1).GetStepStrength(js_Step_LeftHand_MidPoint.val, js_Step_LeftHand_Sharpness.val);

            lHandTargetPos = baseChestPos + (baseBodyRot * new Vector3(-js_LHandSide.val, js_LHandUpDown.val, js_LHandForward.val));
            lHandTargetPos += baseBodyRot * new Vector3(js_LHandStepSide.val * lStepStr, -js_LHandStepUpDown.val * lStepStr, js_LHandStepForward.val * lStepStr);
            lHandTargetPos += baseBodyRot * new Vector3(-js_LHandStepSide.val * rStepStr, js_LHandStepUpDown.val * rStepStr, -js_LHandStepForward.val * rStepStr);

            /* Left Hand Rot */

            lHandTargetRot = baseBodyRot;

            lHandTargetRot *= Quaternion.AngleAxis(js_LHandPitch.val, Vector3.right);
            lHandTargetRot *= Quaternion.AngleAxis(js_LHandYaw.val, Vector3.up);
            lHandTargetRot *= Quaternion.AngleAxis(js_LHandRoll.val, Vector3.forward);

            lHandTargetRot *= Quaternion.AngleAxis(-js_LHandStepPitch.val * lStepStr, Vector3.right);
            lHandTargetRot *= Quaternion.AngleAxis(-js_LHandStepYaw.val * lStepStr, Vector3.up);
            lHandTargetRot *= Quaternion.AngleAxis(-js_LHandStepRoll.val * lStepStr, Vector3.forward);

            lHandTargetRot *= Quaternion.AngleAxis(js_LHandStepPitch.val * rStepStr, Vector3.right);
            lHandTargetRot *= Quaternion.AngleAxis(js_LHandStepYaw.val * rStepStr, Vector3.up);
            lHandTargetRot *= Quaternion.AngleAxis(js_LHandStepRoll.val * rStepStr, Vector3.forward);

            /* Left Elbow */

            rStepStr = stepCycle.GetStep(0).GetStepStrength(js_Step_LeftElbow_MidPoint.val, js_Step_LeftElbow_Sharpness.val);
            lStepStr = stepCycle.GetStep(1).GetStepStrength(js_Step_LeftElbow_MidPoint.val, js_Step_LeftElbow_Sharpness.val);

            lElbowTargetPos = Vector3.Lerp(lShoulderControl.transform.position, lHandControl.transform.position, 0.5f);
            lElbowTargetPos += baseBodyRot * new Vector3(-js_LElbowSide.val, js_LElbowUpDown.val, js_LElbowForward.val);
            lElbowTargetPos += baseBodyRot * new Vector3(-js_LElbowStepSide.val * lStepStr, -js_LElbowStepUpDown.val * lStepStr, js_LElbowStepForward.val * rStepStr);
            lElbowTargetPos += baseBodyRot * new Vector3(js_LElbowStepSide.val * rStepStr, js_LElbowStepUpDown.val * rStepStr, -js_LElbowStepForward.val * lStepStr);

        }

        protected void UpdateRightArmTarget()
        {
            /* Right Shoulder */

            rStepStr = stepCycle.GetStep(0).GetStepStrength(js_Step_RightShoulder_MidPoint.val, js_Step_RightShoulder_Sharpness.val);
            lStepStr = stepCycle.GetStep(1).GetStepStrength(js_Step_RightShoulder_MidPoint.val, js_Step_RightShoulder_Sharpness.val);

            rShoulderTargetPos = baseChestPos + (baseBodyRot * new Vector3(js_RShoulderSide.val, js_RShoulderUpDown.val, js_RShoulderForward.val));
            rShoulderTargetPos += baseBodyRot * new Vector3(js_RShoulderStepSide.val * lStepStr, js_RShoulderStepUpDown.val * lStepStr, js_RShoulderStepForward.val * rStepStr);
            rShoulderTargetPos += baseBodyRot * new Vector3(-js_RShoulderStepSide.val * rStepStr, -js_RShoulderStepUpDown.val * rStepStr, -js_RShoulderStepForward.val * lStepStr);


            /* Right Hand Pos*/

            rStepStr = stepCycle.GetStep(0).GetStepStrength(js_Step_RightHand_MidPoint.val, js_Step_RightHand_Sharpness.val);
            lStepStr = stepCycle.GetStep(1).GetStepStrength(js_Step_RightHand_MidPoint.val, js_Step_RightHand_Sharpness.val);

            rHandTargetPos = baseChestPos + (baseBodyRot * new Vector3(js_RHandSide.val, js_RHandUpDown.val, js_RHandForward.val));
            rHandTargetPos += baseBodyRot * new Vector3(-js_RHandStepSide.val * lStepStr, -js_RHandStepUpDown.val * lStepStr, js_RHandStepForward.val * lStepStr);
            rHandTargetPos += baseBodyRot * new Vector3(js_RHandStepSide.val * rStepStr, js_RHandStepUpDown.val * rStepStr, -js_RHandStepForward.val * rStepStr);

            /* Right Hand Rot */

            rHandTargetRot = baseBodyRot;
            
            rHandTargetRot *= Quaternion.AngleAxis(js_RHandPitch.val, Vector3.right);
            rHandTargetRot *= Quaternion.AngleAxis(-js_RHandYaw.val, Vector3.up);
            rHandTargetRot *= Quaternion.AngleAxis(-js_RHandRoll.val, Vector3.forward);
            
            rHandTargetRot *= Quaternion.AngleAxis(-js_RHandStepPitch.val * rStepStr, Vector3.right);
            rHandTargetRot *= Quaternion.AngleAxis(-js_RHandStepYaw.val * rStepStr, Vector3.up);
            rHandTargetRot *= Quaternion.AngleAxis(js_RHandStepRoll.val * rStepStr, Vector3.forward);
            
            rHandTargetRot *= Quaternion.AngleAxis(js_RHandStepPitch.val * lStepStr, Vector3.right);
            rHandTargetRot *= Quaternion.AngleAxis(js_RHandStepYaw.val * lStepStr, Vector3.up);
            rHandTargetRot *= Quaternion.AngleAxis(-js_RHandStepRoll.val * lStepStr, Vector3.forward);

            /* Right Elbow */

            rStepStr = stepCycle.GetStep(0).GetStepStrength(js_Step_RightElbow_MidPoint.val, js_Step_RightElbow_Sharpness.val);
            lStepStr = stepCycle.GetStep(1).GetStepStrength(js_Step_RightElbow_MidPoint.val, js_Step_RightElbow_Sharpness.val);

            rElbowTargetPos = Vector3.Lerp(rShoulderControl.transform.position, rHandControl.transform.position, 0.5f);
            rElbowTargetPos += baseBodyRot * new Vector3(js_RElbowSide.val, js_RElbowUpDown.val, js_RElbowForward.val);
            rElbowTargetPos += baseBodyRot * new Vector3(-js_RElbowStepSide.val * lStepStr, js_RElbowStepUpDown.val * lStepStr, js_RElbowStepForward.val * rStepStr);
            rElbowTargetPos += baseBodyRot * new Vector3(js_RElbowStepSide.val * rStepStr, -js_RElbowStepUpDown.val * rStepStr, -js_RElbowStepForward.val * lStepStr);
        }

        protected void UpdatePresetTransition()
        {
            if (presetTransitionActive)
            {
                float _presetLoadTime = Mathf.Clamp01((Time.time - presetTransitionStartTime) / manager.PresetTransitionSpeed);

                for (int i = 0; i < floatStorables.Count; i++)
                {

                    if (floatStorables[i] == js_StepsDuration && !js_TogglePresetUpdate_StepDuration.val)
                    {
                        continue;
                    }

                    if (floatStorables[i] == js_DanceAmplitude && !js_TogglePresetUpdate_DanceAmplitude.val)
                    {
                        continue;
                    }

                    floatStorables[i].val = Mathf.Lerp(presetLoadStartData.floatData[i], presetLoadEndData.floatData[i], _presetLoadTime);
                }

                if (_presetLoadTime >= 1)
                {
                    presetTransitionActive = false;

                    manager.trigger_OnPresetLoaded.Trigger();
                }
            }
        }

        /* Legs sub functions */

        protected Vector3 tmpTargetPos;
        protected Quaternion tmpTargetRot;
        protected float stepHeightAdaptation;
        protected float stepHeightAdaptation_Down = 0.6f;
        protected float stepHeightAdapatation_Up = 0.9f;

        protected Vector3 ComputeRFootPos_Standing()
        {
            rStepStr = stepCycle.GetStep(0).GetStepStrength(js_Step_RightFoot_MidPoint.val, js_Step_RightFoot_Sharpness.val);
            lStepStr = stepCycle.GetStep(1).GetStepStrength(js_Step_RightFoot_MidPoint.val, js_Step_RightFoot_Sharpness.val);

            stepHeightAdaptation = stepCycle.GetStep(0).StepHeightDelta >= 0 ? stepHeightAdapatation_Up : stepHeightAdaptation_Down;

            tmpTargetPos = stepCycle.GetStep(0).TargetPos;
            tmpTargetPos += manager.TargetTransform.rotation * new Vector3(js_RFootSide.val, js_RFootUpDown.val, js_RFootForward.val);

            tmpTargetPos += manager.TargetTransform.rotation * new Vector3(js_RFootStepSide.val, js_RFootStepUpDown.val, js_RFootStepForward.val) * rStepStr;

            if (js_MoveFeetOnBothSteps.val)
            {
                tmpTargetPos += manager.TargetTransform.rotation * new Vector3(js_RFootStepSide.val, js_RFootStepUpDown.val, js_RFootStepForward.val) * lStepStr;
            }

            tmpTargetPos.y += Mathf.Abs(stepCycle.GetStep(0).StepHeightDelta) * stepHeightAdaptation * stepCycle.GetStep(0).GetStepStrength(js_Step_RightFoot_MidPoint.val, js_Step_RightFoot_Sharpness.val, false);

            return tmpTargetPos;
        }

        protected Vector3 ComputeLFootPos_Standing()
        {
            rStepStr = stepCycle.GetStep(0).GetStepStrength(js_Step_LeftFoot_MidPoint.val, js_Step_LeftFoot_Sharpness.val);
            lStepStr = stepCycle.GetStep(1).GetStepStrength(js_Step_LeftFoot_MidPoint.val, js_Step_LeftFoot_Sharpness.val);

            stepHeightAdaptation = stepCycle.GetStep(1).StepHeightDelta >= 0 ? stepHeightAdapatation_Up : stepHeightAdaptation_Down;

            tmpTargetPos = stepCycle.GetStep(1).TargetPos;
            tmpTargetPos += manager.TargetTransform.rotation * new Vector3(-js_LFootSide.val, js_LFootUpDown.val, js_LFootForward.val);

            tmpTargetPos += manager.TargetTransform.rotation * new Vector3(-js_LFootStepSide.val, js_LFootStepUpDown.val, js_LFootStepForward.val) * lStepStr;

            if (js_MoveFeetOnBothSteps.val)
            {
                tmpTargetPos += manager.TargetTransform.rotation * new Vector3(-js_LFootStepSide.val, js_LFootStepUpDown.val, js_LFootStepForward.val) * rStepStr;
            }

            tmpTargetPos.y += Mathf.Abs(stepCycle.GetStep(1).StepHeightDelta) * stepHeightAdaptation * stepCycle.GetStep(1).GetStepStrength(js_Step_LeftFoot_MidPoint.val, js_Step_LeftFoot_Sharpness.val, false);

            return tmpTargetPos;
        }

        protected Quaternion ComputeRFootRot_Standing()
        {
            rStepStr = stepCycle.GetStep(0).GetStepStrength(js_Step_RightFoot_MidPoint.val, js_Step_RightFoot_Sharpness.val);
            lStepStr = stepCycle.GetStep(1).GetStepStrength(js_Step_LeftFoot_MidPoint.val, js_Step_LeftFoot_Sharpness.val);

            tmpTargetRot = stepCycle.GetStep(0).TargetRot;

            tmpTargetRot *= Quaternion.AngleAxis(js_RFootPitch.val, Vector3.right);
            tmpTargetRot *= Quaternion.AngleAxis(js_RFootYaw.val, Vector3.up);
            tmpTargetRot *= Quaternion.AngleAxis(js_RFootRoll.val, Vector3.forward);

            tmpTargetRot *= Quaternion.AngleAxis(js_RFootStepPitch.val * rStepStr, Vector3.right);
            tmpTargetRot *= Quaternion.AngleAxis(js_RFootStepYaw.val * rStepStr, Vector3.up);
            tmpTargetRot *= Quaternion.AngleAxis(js_RFootStepRoll.val * rStepStr, Vector3.forward);

            if (js_MoveFeetOnBothSteps.val)
            {
                tmpTargetRot *= Quaternion.AngleAxis(js_RFootStepPitch.val * rStepStr, Vector3.right);
                tmpTargetRot *= Quaternion.AngleAxis(js_RFootStepYaw.val * rStepStr, Vector3.up);
                tmpTargetRot *= Quaternion.AngleAxis(js_RFootStepRoll.val * lStepStr, Vector3.forward);
            }

            return tmpTargetRot;
        }

        protected Quaternion ComputeLFootRot_Standing()
        {
            rStepStr = stepCycle.GetStep(0).GetStepStrength(js_Step_RightFoot_MidPoint.val, js_Step_RightFoot_Sharpness.val);
            lStepStr = stepCycle.GetStep(1).GetStepStrength(js_Step_LeftFoot_MidPoint.val, js_Step_LeftFoot_Sharpness.val);

            tmpTargetRot = stepCycle.GetStep(1).TargetRot;

            tmpTargetRot *= Quaternion.AngleAxis(js_LFootPitch.val, Vector3.right);
            tmpTargetRot *= Quaternion.AngleAxis(-js_LFootYaw.val, Vector3.up);
            tmpTargetRot *= Quaternion.AngleAxis(-js_LFootRoll.val, Vector3.forward);

            tmpTargetRot *= Quaternion.AngleAxis(js_LFootStepPitch.val * lStepStr, Vector3.right);
            tmpTargetRot *= Quaternion.AngleAxis(-js_LFootStepYaw.val * lStepStr, Vector3.up);
            tmpTargetRot *= Quaternion.AngleAxis(-js_LFootStepRoll.val * lStepStr, Vector3.forward);

            if (js_MoveFeetOnBothSteps.val)
            {
                tmpTargetRot *= Quaternion.AngleAxis(js_LFootStepPitch.val * lStepStr, Vector3.right);
                tmpTargetRot *= Quaternion.AngleAxis(-js_LFootStepYaw.val * lStepStr, Vector3.up);
                tmpTargetRot *= Quaternion.AngleAxis(-js_LFootStepRoll.val * rStepStr, Vector3.forward);
            }

            return tmpTargetRot;
        }

        protected Vector3 ComputeRKneePos_Standing()
        {
            rStepStr = stepCycle.GetStep(0).GetStepStrength(js_Step_RightKnee_MidPoint.val, js_Step_RightKnee_Sharpness.val);
            lStepStr = stepCycle.GetStep(1).GetStepStrength(js_Step_LeftKnee_MidPoint.val, js_Step_LeftKnee_Sharpness.val);

            tmpTargetPos = Vector3.Lerp(hipControl.transform.position, rFootControl.transform.position, 0.5f);
            tmpTargetPos += stepCycle.GetStep(0).TargetRot * new Vector3(js_RKneeSide.val, js_RKneeUpDown.val, js_RKneeForward.val + kneesBodyHeightFactor);
            tmpTargetPos += stepCycle.GetStep(0).TargetRot * new Vector3(js_RKneeStepSide.val, js_RKneeStepUpDown.val, js_RKneeStepForward.val) * rStepStr;

            if (js_MoveKneesOnBothSteps.val)
            {
                tmpTargetPos += stepCycle.GetStep(0).TargetRot * new Vector3(js_RKneeStepSide.val, js_RKneeStepUpDown.val, js_RKneeStepForward.val) * lStepStr;
            }

            return tmpTargetPos;
        }

        protected Vector3 ComputeLKneePos_Standing()
        {
            rStepStr = stepCycle.GetStep(0).GetStepStrength(js_Step_RightKnee_MidPoint.val, js_Step_RightKnee_Sharpness.val);
            lStepStr = stepCycle.GetStep(1).GetStepStrength(js_Step_LeftKnee_MidPoint.val, js_Step_LeftKnee_Sharpness.val);

            tmpTargetPos = Vector3.Lerp(hipControl.transform.position, lFootControl.transform.position, 0.5f);
            tmpTargetPos += stepCycle.GetStep(1).TargetRot * new Vector3(-js_LKneeSide.val, js_LKneeUpDown.val, js_LKneeForward.val + kneesBodyHeightFactor);
            tmpTargetPos += stepCycle.GetStep(1).TargetRot * new Vector3(-js_LKneeStepSide.val, js_LKneeStepUpDown.val, js_LKneeStepForward.val) * lStepStr;

            if (js_MoveKneesOnBothSteps.val)
            {
                tmpTargetPos += stepCycle.GetStep(1).TargetRot * new Vector3(-js_LKneeStepSide.val, js_LKneeStepUpDown.val, js_LKneeStepForward.val) * rStepStr;
            }

            return tmpTargetPos;
        }

        protected Vector3 ComputeRFootPos_Kneeling()
        {
            tmpTargetPos = rKneeTargetPos + (stepCycle.GetStep(0).TargetRot * Quaternion.Euler(js_LegsPitchKneeling.val, js_LegsYawKneeling.val, 0) * -Vector3.forward * shinLength);

            return tmpTargetPos;
        }

        protected Vector3 ComputeLFootPos_Kneeling()
        {
            tmpTargetPos = lKneeTargetPos + (stepCycle.GetStep(1).TargetRot * Quaternion.Euler(js_LegsPitchKneeling.val, -js_LegsYawKneeling.val, 0) * -Vector3.forward * shinLength);

            return tmpTargetPos;
        }

        protected Quaternion ComputeRFootRot_Kneeling()
        {
            tmpTargetRot = stepCycle.GetStep(0).TargetRot * Quaternion.Euler(175, 0, js_LegsRollKneeling.val);

            return tmpTargetRot;
        }

        protected Quaternion ComputeLFootRot_Kneeling()
        {
            tmpTargetRot = stepCycle.GetStep(1).TargetRot * Quaternion.Euler(175, 0, -js_LegsRollKneeling.val);

            return tmpTargetRot;
        }

        protected Vector3 ComputeRKneePos_Kneeling()
        {
            rStepStr = stepCycle.GetStep(0).GetStepStrength(js_Step_RightFoot_MidPoint.val, js_Step_RightFoot_Sharpness.val);
            lStepStr = stepCycle.GetStep(1).GetStepStrength(js_Step_LeftFoot_MidPoint.val, js_Step_LeftFoot_Sharpness.val);

            stepHeightAdaptation = stepCycle.GetStep(0).StepHeightDelta >= 0 ? stepHeightAdapatation_Up : stepHeightAdaptation_Down;

            tmpTargetPos = stepCycle.GetStep(0).TargetPos;
            tmpTargetPos += manager.TargetTransform.rotation * new Vector3(js_KneeStepBowKneeling.val, js_KneeStepHeightKneeling.val, 0) * rStepStr;

            if (js_MoveKneesOnBothSteps.val)
            {
                tmpTargetPos += manager.TargetTransform.rotation * new Vector3(js_KneeStepBowKneeling.val, js_KneeStepHeightKneeling.val, 0) * lStepStr;
            }

            tmpTargetPos.y += Mathf.Abs(stepCycle.GetStep(0).StepHeightDelta) * stepHeightAdaptation * stepCycle.GetStep(0).GetStepStrength(js_Step_RightFoot_MidPoint.val, js_Step_RightFoot_Sharpness.val, false);

            return tmpTargetPos;
        }

        protected Vector3 ComputeLKneePos_Kneeling()
        {
            rStepStr = stepCycle.GetStep(0).GetStepStrength(js_Step_RightFoot_MidPoint.val, js_Step_RightFoot_Sharpness.val);
            lStepStr = stepCycle.GetStep(1).GetStepStrength(js_Step_LeftFoot_MidPoint.val, js_Step_LeftFoot_Sharpness.val);

            stepHeightAdaptation = stepCycle.GetStep(1).StepHeightDelta >= 0 ? stepHeightAdapatation_Up : stepHeightAdaptation_Down;

            tmpTargetPos = stepCycle.GetStep(1).TargetPos;
            tmpTargetPos += manager.TargetTransform.rotation * new Vector3(-js_KneeStepBowKneeling.val, js_KneeStepHeightKneeling.val, 0) * lStepStr;

            if (js_MoveKneesOnBothSteps.val)
            {
                tmpTargetPos += manager.TargetTransform.rotation * new Vector3(-js_KneeStepBowKneeling.val, js_KneeStepHeightKneeling.val, 0) * rStepStr;
            }

            tmpTargetPos.y += Mathf.Abs(stepCycle.GetStep(1).StepHeightDelta) * stepHeightAdaptation * stepCycle.GetStep(1).GetStepStrength(js_Step_LeftFoot_MidPoint.val, js_Step_LeftFoot_Sharpness.val, false);

            return tmpTargetPos;
        }


        /* Actions Callbacks */

        protected void Action_IncrementStepDuration()
        {
            js_StepsDuration.val = Mathf.Clamp(js_StepsDuration.val + js_Action_StepDurationChange.val, 0.1f, 2f);
        }

        protected void Action_DecrementStepDuration()
        {
            js_StepsDuration.val = Mathf.Clamp(js_StepsDuration.val - js_Action_StepDurationChange.val, 0.1f, 2f);
        }

        protected void Action_IncrementDanceAmplitude()
        {
            js_DanceAmplitude.val = Mathf.Clamp(js_DanceAmplitude.val + js_Action_DanceAmplitudeChange.val, 0.1f, 2f);
        }

        protected void Action_DecrementDanceAmplitude()
        {
            js_DanceAmplitude.val = Mathf.Clamp(js_DanceAmplitude.val - js_Action_DanceAmplitudeChange.val, 0.1f, 2f);
        }

        protected void Action_IncrementRotationOffset()
        {
            manager.RotationOffset = Mathf.Clamp(manager.RotationOffset + js_Action_RotationOffsetChange.val, -180f, 180f);
        }

        protected void Action_DecrementRotationOffset()
        {
            manager.RotationOffset = Mathf.Clamp(manager.RotationOffset - js_Action_RotationOffsetChange.val, -180f, 180f);
        }


        float lastBeatSyncTime = -1f;
        float lastBeatInterval = 0f;

        protected void _Action_SyncBeat()
        {
            if (Time.time - lastBeatSyncTime > 1f)
                lastBeatSyncTime = -1f;

            if (lastBeatInterval == 0)
                lastBeatInterval = js_StepsDuration.val;

            if (lastBeatSyncTime > 0)
                lastBeatInterval = (lastBeatInterval + Time.time - lastBeatSyncTime) / 2;
               
            lastBeatSyncTime = Time.time;

            stepCycle.SetAllStepsDurations(lastBeatInterval);
        }

        /* Global Callbacks */

        public void Callback_ResetStepTime()
        {
            stepCycle.ResetStepTiming();
        }

        protected void Callback_UpdateStepCycleParameters(float _val)
        {
            /* Back Step Cycle */

            stepCycle.StepInPlaceAmplitude = js_DanceAmplitude.val;
            stepCycle.StepInPlace = js_DanceMode.val;
            stepCycle.StepSpacingIdle = js_StepsXOffsetIdle.val;
            stepCycle.StepSpacingMoving = js_StepsXOffset.val;
            stepCycle.StepSpacingKneelingIdle = js_KneeXOffsetKneelingIdle.val;
            stepCycle.StepSpacingKneelingMoving = js_KneeXOffsetKneelingMoving.val;
            stepCycle.GroundOffset = js_StepsYOffset.val;
            stepCycle.GroundOffsetKneeling = js_KneeYOffsetKneeling.val;

            stepCycle.StepDurationRandom_Min = js_DurationRandom_Min.val;
            stepCycle.StepDurationRandom_Max = js_DurationRandom_Max.val;
            stepCycle.StepSpacingRandom_Min = js_XOffsetRandom_Min.val;
            stepCycle.StepSpacingRandom_Max = js_XOffsetRandom_Max.val;

            Step _step = stepCycle.GetStep(0);

            _step.Duration = js_StepsDuration.val;
            _step.Delay = js_StepsDelay.val;

            _step = stepCycle.GetStep(1);

            _step.Duration = js_StepsDuration.val;
            _step.Delay = js_StepsDelay.val;
        }

        protected void Callback_UpdateStepInPlace(bool _newVal)
        {
            stepCycle.StepInPlace = _newVal;

            manager.TempRotationOffset = 0;
        }

        protected void Callback_UpdateAutoRotate(bool _newVal)
        {
            manager.TempRotationOffset = 0;
        }

        protected void Event_StartStepIdle(bool _newState)
        {
            manager.trigger_OnStepIdleStart.Trigger();
        }

        protected void Callback_UpdateBodyControlToggles(bool _newVal)
        {
            updateHipTarget = js_UpdateHipControl.val;
            updateChestTarget = js_UpdateChestControl.val;
            updateNeckTarget = js_UpdateNeckControl.val;

            updateRFootTarget = js_UpdateRFootControl.val;
            updateLFootTarget = js_UpdateLFootControl.val;
            updateRKneeTarget = js_UpdateRKneeControl.val;
            updateLkneeTarget = js_UpdateLKneeControl.val;

            updateRShoulderTarget = js_UpdateRShoulderControl.val;
            updateLShoulderTarget = js_UpdateLShoulderControl.val;
            updateRHandTarget = js_UpdateRHandControl.val;
            updateLHandTarget = js_UpdateLHandControl.val;
            updateRElbowTarget = js_UpdateRElbowControl.val;
            updateLElbowTarget = js_UpdateLElbowControl.val;
        }

        protected void Callback_ZeroAllStepParameters()
        {
            js_Step_BodyHeight.val = 0;

            js_Step_BodyYaw.val = 0;
            js_Step_BodyPitch.val = 0;
            js_Step_BodyRoll.val = 0;

            js_HipsStepSide.val = 0;
            js_HipsStepUpDown.val = 0;
            js_HipsStepForward.val = 0;

            js_HipsStepYaw.val = 0;
            js_HipsStepPitch.val = 0;
            js_HipsStepRoll.val = 0;

            js_ChestStepSide.val = 0;
            js_ChestStepUpDown.val = 0;
            js_ChestStepForward.val = 0;

            js_ChestStepYaw.val = 0;
            js_ChestStepPitch.val = 0;
            js_ChestStepRoll.val = 0;

            js_NeckStepSide.val = 0;
            js_NeckStepUpDown.val = 0;
            js_NeckStepForward.val = 0;

            js_NeckStepYaw.val = 0;
            js_NeckStepPitch.val = 0;
            js_NeckStepRoll.val = 0;

            js_RShoulderStepSide.val = 0;
            js_RShoulderStepUpDown.val = 0;
            js_RShoulderStepForward.val = 0;

            js_RElbowStepSide.val = 0;
            js_RElbowStepUpDown.val = 0;
            js_RElbowStepForward.val = 0;

            js_RHandStepSide.val = 0;
            js_RHandStepUpDown.val = 0;
            js_RHandStepForward.val = 0;

            js_RHandStepYaw.val = 0;
            js_RHandStepPitch.val = 0;
            js_RHandStepRoll.val = 0;

            js_LShoulderStepSide.val = 0;
            js_LShoulderStepUpDown.val = 0;
            js_LShoulderStepForward.val = 0;

            js_LElbowStepSide.val = 0;
            js_LElbowStepUpDown.val = 0;
            js_LElbowStepForward.val = 0;

            js_LHandStepSide.val = 0;
            js_LHandStepUpDown.val = 0;
            js_LHandStepForward.val = 0;

            js_LHandStepYaw.val = 0;
            js_LHandStepPitch.val = 0;
            js_LHandStepRoll.val = 0;

            js_RKneeStepSide.val = 0;
            js_RKneeStepUpDown.val = 0;
            js_RKneeStepForward.val = 0;

            js_RFootStepSide.val = 0;
            js_RFootStepUpDown.val = 0;
            js_RFootStepForward.val = 0;

            js_RFootStepYaw.val = 0;
            js_RFootStepPitch.val = 0;
            js_RFootStepRoll.val = 0;

            js_LKneeStepSide.val = 0;
            js_LKneeStepUpDown.val = 0;
            js_LKneeStepForward.val = 0;

            js_LFootStepSide.val = 0;
            js_LFootStepUpDown.val = 0;
            js_LFootStepForward.val = 0;

            js_LFootStepYaw.val = 0;
            js_LFootStepPitch.val = 0;
            js_LFootStepRoll.val = 0;

            js_KneeStepHeightKneeling.val = 0;
            js_KneeStepBowKneeling.val = 0;
        }

        /* Arms Callbacks */


        public void Callback_CopyArm_LeftRight()
        {
            js_RShoulderSide.val = js_LShoulderSide.val;
            js_RShoulderUpDown.val = js_LShoulderUpDown.val;
            js_RShoulderForward.val = js_LShoulderForward.val;
            js_RHandSide.val = js_LHandSide.val;
            js_RHandUpDown.val = js_LHandUpDown.val;
            js_RHandForward.val = js_LHandForward.val;
            js_RHandYaw.val = js_LHandYaw.val;
            js_RHandPitch.val = js_LHandPitch.val;
            js_RHandRoll.val = js_LHandRoll.val;
            js_RElbowSide.val = js_LElbowSide.val;
            js_RElbowUpDown.val = js_LElbowUpDown.val;
            js_RElbowForward.val = js_LElbowForward.val;
            js_RElbowStepUpDown.val = js_LElbowStepUpDown.val;

            js_RShoulderStepSide.val = js_LShoulderStepSide.val;
            js_RShoulderStepUpDown.val = -js_LShoulderStepUpDown.val;
            js_RShoulderStepForward.val = js_LShoulderStepForward.val;
            js_RHandStepSide.val = -js_LHandStepSide.val;
            js_RHandStepUpDown.val = -js_LHandStepUpDown.val;
            js_RHandStepForward.val = -js_LHandStepForward.val;
            js_RHandStepYaw.val = -js_LHandStepYaw.val;
            js_RHandStepPitch.val = js_LHandStepPitch.val;
            js_RHandStepRoll.val = js_LHandStepRoll.val;
            js_RElbowStepForward.val = -js_LElbowStepForward.val;
            js_RElbowStepSide.val = js_LElbowStepSide.val;

            js_Step_RightHand_MidPoint.val = js_Step_LeftHand_MidPoint.val;
            js_Step_RightHand_Sharpness.val = js_Step_LeftHand_Sharpness.val;
            js_Step_RightElbow_MidPoint.val = js_Step_LeftElbow_MidPoint.val;
            js_Step_RightElbow_Sharpness.val = js_Step_LeftElbow_Sharpness.val;
            js_Step_RightShoulder_MidPoint.val = js_Step_LeftShoulder_MidPoint.val;
            js_Step_RightShoulder_Sharpness.val = js_Step_LeftShoulder_Sharpness.val;
        }

        public void Callback_CopyArm_RightLeft()
        {
            js_LShoulderSide.val = js_RShoulderSide.val;
            js_LShoulderUpDown.val = js_RShoulderUpDown.val;
            js_LShoulderForward.val = js_RShoulderForward.val;
            js_LHandSide.val = js_RHandSide.val;
            js_LHandUpDown.val = js_RHandUpDown.val;
            js_LHandForward.val = js_RHandForward.val;
            js_LHandYaw.val = js_RHandYaw.val;
            js_LHandPitch.val = js_RHandPitch.val;
            js_LHandRoll.val = js_RHandRoll.val;
            js_LElbowSide.val = js_RElbowSide.val;
            js_LElbowUpDown.val = js_RElbowUpDown.val;
            js_LElbowForward.val = js_RElbowForward.val;
            js_LElbowStepUpDown.val = js_RElbowStepUpDown.val;

            js_LShoulderStepSide.val = js_RShoulderStepSide.val;
            js_LShoulderStepUpDown.val = -js_RShoulderStepUpDown.val;
            js_LShoulderStepForward.val = js_RShoulderStepForward.val;
            js_LHandStepSide.val = -js_RHandStepSide.val;
            js_LHandStepUpDown.val = -js_RHandStepUpDown.val;
            js_LHandStepForward.val = -js_RHandStepForward.val;
            js_LHandStepYaw.val = -js_RHandStepYaw.val;
            js_LHandStepPitch.val = js_RHandStepPitch.val;
            js_LHandStepRoll.val = js_RHandStepRoll.val;
            js_LElbowStepForward.val = -js_RElbowStepForward.val;
            js_LElbowStepSide.val = js_RElbowStepSide.val;

            js_Step_LeftHand_MidPoint.val = js_Step_RightHand_MidPoint.val;
            js_Step_LeftHand_Sharpness.val = js_Step_RightHand_Sharpness.val;
            js_Step_LeftElbow_MidPoint.val = js_Step_RightElbow_MidPoint.val;
            js_Step_LeftElbow_Sharpness.val = js_Step_RightElbow_Sharpness.val;
            js_Step_LeftShoulder_MidPoint.val = js_Step_RightShoulder_MidPoint.val;
            js_Step_LeftShoulder_Sharpness.val = js_Step_RightShoulder_Sharpness.val;
        }

        /* Legs Callbacks */

        public void Callback_CopyLeg_LeftRight()
        {
            js_RFootSide.val = js_LFootSide.val;
            js_RFootUpDown.val = js_LFootUpDown.val;
            js_RFootForward.val = js_LFootForward.val;

            js_RFootStepSide.val = js_LFootStepSide.val;
            js_RFootStepUpDown.val = js_LFootStepUpDown.val;
            js_RFootStepForward.val = js_LFootStepForward.val;

            js_RFootYaw.val = js_LFootYaw.val;
            js_RFootPitch.val = js_LFootPitch.val;
            js_RFootRoll.val = js_LFootRoll.val;

            js_RFootStepYaw.val = js_LFootStepYaw.val;
            js_RFootStepPitch.val = js_LFootStepPitch.val;
            js_RFootStepRoll.val = js_LFootStepRoll.val;

            js_RKneeSide.val = js_LKneeSide.val;
            js_RKneeUpDown.val = js_LKneeUpDown.val;
            js_RKneeForward.val = js_LKneeForward.val;

            js_RKneeStepSide.val = js_LKneeStepSide.val;
            js_RKneeStepUpDown.val = js_LKneeStepUpDown.val;
            js_RKneeStepForward.val = js_LKneeStepForward.val;

            js_Step_RightFoot_MidPoint.val = js_Step_LeftFoot_MidPoint.val;
            js_Step_RightFoot_Sharpness.val = js_Step_LeftFoot_Sharpness.val;
            js_Step_RightKnee_MidPoint.val = js_Step_LeftKnee_MidPoint.val;
            js_Step_RightKnee_Sharpness.val = js_Step_LeftKnee_Sharpness.val;
        }

        public void Callback_CopyLeg_RightLeft()
        {
            js_LFootSide.val = js_RFootSide.val;
            js_LFootUpDown.val = js_RFootUpDown.val;
            js_LFootForward.val = js_RFootForward.val;

            js_LFootStepSide.val = js_RFootStepSide.val;
            js_LFootStepUpDown.val = js_RFootStepUpDown.val;
            js_LFootStepForward.val = js_RFootStepForward.val;

            js_LFootYaw.val = js_RFootYaw.val;
            js_LFootPitch.val = js_RFootPitch.val;
            js_LFootRoll.val = js_RFootRoll.val;

            js_LFootStepYaw.val = js_RFootStepYaw.val;
            js_LFootStepPitch.val = js_RFootStepPitch.val;
            js_LFootStepRoll.val = js_RFootStepRoll.val;

            js_LKneeSide.val = js_RKneeSide.val;
            js_LKneeUpDown.val = js_RKneeUpDown.val;
            js_LKneeForward.val = js_RKneeForward.val;

            js_LKneeStepSide.val = js_RKneeStepSide.val;
            js_LKneeStepUpDown.val = js_RKneeStepUpDown.val;
            js_LKneeStepForward.val = js_RKneeStepForward.val;

            js_Step_LeftFoot_MidPoint.val = js_Step_RightFoot_MidPoint.val;
            js_Step_LeftFoot_Sharpness.val = js_Step_RightFoot_Sharpness.val;
            js_Step_LeftKnee_MidPoint.val = js_Step_RightKnee_MidPoint.val;
            js_Step_LeftKnee_Sharpness.val = js_Step_RightKnee_Sharpness.val;
        }

        /* Control Grab Callbacks */

        protected void Callback_OnHeadGrab(FreeControllerV3 fcv3)
        {
            neckControl.currentPositionState = FreeControllerV3.PositionState.Off;
            neckControl.currentRotationState = FreeControllerV3.RotationState.Off;
        }

        protected void Callback_OnHeadRelease(FreeControllerV3 fcv3)
        {
            neckControl.currentPositionState = FreeControllerV3.PositionState.On;
            neckControl.currentRotationState = FreeControllerV3.RotationState.On;
        }


        /* Helpers */

        protected void UpdateBodyProportions()
        {
            armLength = (rShoulderForceReceiver.transform.position - rElbowForceReceiver.transform.position).magnitude;

            forearmLength = (rElbowForceReceiver.transform.position - rHandForceReceiver.transform.position).magnitude;

            shinLength = (rKneeForceReceiver.transform.position - rFootForceReceiver.transform.position).magnitude;

            thighLength = (rThighForceReceiver.transform.position - rKneeForceReceiver.transform.position).magnitude;
        }

        #endregion

        #region Dance System

        /* Dance Functions */

        float autoRotStartTime = 0;
        float autoRotDelay = 0;
        float autoRotTime = 0;
        float autoRotChange = 0;
        float autoRotTarget = 0;

        float amplitudeStartTime = 0, amplitudeChange, amplitudeTarget, amplitudeCurrent, amplitudeStart;

        float hipsAutoRotStartTime = 0, hipsAutoRotChange, hipsAutoRotTarget, hipsAutoRotCurrent, hipsAutoRotStart;
        float chestAutoRotStartTime = 0, chestAutoRotChange, chestAutoRotTarget, chestAutoRotCurrent, chestAutoRotStart;
        float neckAutoRotStartTime = 0, neckAutoRotChange, neckAutoRotTarget, neckAutoRotCurrent, neckAutoRotStart;

        protected void UpdateDanceMode()
        {
            if (js_DanceMode.val == false)
            {
                autoRotTarget = 0;
                amplitudeCurrent = 0;
                hipsAutoRotCurrent = 0;
                chestAutoRotCurrent = 0;
                neckAutoRotCurrent = 0;

                return;
            }

            UpdateDanceRotation();
            UpdateDanceAmplitude();
            UpdateDanceHips();
            UpdateDanceChest();
            UpdateDanceNeck();
        }

        protected void UpdateDanceRotation()
        {
            if (js_AutoRotate.val)
            {
                autoRotDelay = Mathf.Clamp((stepCycle.GetStep(0).Duration + stepCycle.GetStep(0).Delay) * js_AutoRotDelayMult.val, 0.01f, 1000);
                autoRotTime = Mathf.Clamp01((Time.time - autoRotStartTime) / autoRotDelay);

                if (autoRotTime >= 1)
                {
                    autoRotStartTime = Time.time;

                    autoRotChange = UnityEngine.Random.Range(js_AutoRotAngleChangeMin.val, js_AutoRotAngleChangeMax.val) * stepCycle.StepInPlaceAmplitude;

                    if (UnityEngine.Random.value > 0.5f)
                        autoRotChange = -autoRotChange;

                    if (autoRotTarget + manager.TempRotationOffset > js_AutoRotAngleMax.val ||  manager.TempRotationOffset + autoRotTarget < -js_AutoRotAngleMin.val)
                        autoRotTarget = Mathf.Clamp(manager.TempRotationOffset - autoRotChange, -js_AutoRotAngleMin.val, js_AutoRotAngleMax.val);
                    else
                        autoRotTarget = Mathf.Clamp(manager.TempRotationOffset + autoRotChange, -js_AutoRotAngleMin.val, js_AutoRotAngleMax.val);

                    manager.TempRotationOffset = autoRotTarget;
                }
            }
        }

        protected void UpdateDanceAmplitude()
        {
            if (js_RandomAmplitude.val)
            {
                autoRotDelay = Mathf.Clamp((stepCycle.GetStep(0).Duration + stepCycle.GetStep(0).Delay) * js_DanceAmplitudeDelayMult.val, 0.01f, 1000);
                autoRotTime = Mathf.Clamp01((Time.time - amplitudeStartTime) / autoRotDelay);

                if (autoRotTime >= 1)
                {
                    amplitudeStartTime = Time.time;
                    autoRotTime = 0;

                    amplitudeChange = UnityEngine.Random.Range(-js_DanceAmplitudeChange.val, js_DanceAmplitudeChange.val) * stepCycle.StepInPlaceAmplitude;

                    amplitudeStart = amplitudeTarget;

                    if (amplitudeTarget + amplitudeChange > js_DanceAmplitudeChangeLimit.val || amplitudeTarget + amplitudeChange < -js_DanceAmplitudeChangeLimit.val)
                        amplitudeTarget = Mathf.Clamp(amplitudeTarget - amplitudeChange, -js_DanceAmplitudeChangeLimit.val, js_DanceAmplitudeChangeLimit.val);
                    else
                        amplitudeTarget = Mathf.Clamp(amplitudeTarget + amplitudeChange, -js_DanceAmplitudeChangeLimit.val, js_DanceAmplitudeChangeLimit.val);

                }

                amplitudeCurrent = Mathf.Lerp(amplitudeStart, amplitudeTarget, autoRotTime);
            }
            else
                amplitudeCurrent = 0;

            stepCycle.StepInPlaceAmplitudeOffset = amplitudeCurrent;
        }

        protected void UpdateDanceHips()
        {
            if (js_HipsAutoRotate.val)
            {
                autoRotDelay = Mathf.Clamp((stepCycle.GetStep(0).Duration + stepCycle.GetStep(0).Delay) * js_HipsAutoRotDelayMult.val, 0.01f, 1000);
                autoRotTime = Mathf.Clamp01((Time.time - hipsAutoRotStartTime) / autoRotDelay);

                if (autoRotTime >= 1)
                {
                    hipsAutoRotStartTime = Time.time;
                    autoRotTime = 0;

                    hipsAutoRotChange = UnityEngine.Random.Range(js_HipsAutoRotAngleChangeMin.val, js_HipsAutoRotAngleChangeMax.val) * stepCycle.StepInPlaceAmplitude;

                    if (UnityEngine.Random.value > 0.5f)
                        hipsAutoRotChange = -hipsAutoRotChange;

                    hipsAutoRotStart = hipsAutoRotTarget;

                    if (hipsAutoRotTarget + hipsAutoRotChange > js_HipsAutoRotAngleMax.val || hipsAutoRotTarget + hipsAutoRotChange < -js_HipsAutoRotAngleMin.val)
                        hipsAutoRotTarget = Mathf.Clamp(hipsAutoRotTarget - hipsAutoRotChange, -js_HipsAutoRotAngleMin.val, js_HipsAutoRotAngleMax.val);
                    else
                        hipsAutoRotTarget = Mathf.Clamp(hipsAutoRotTarget + hipsAutoRotChange, -js_HipsAutoRotAngleMin.val, js_HipsAutoRotAngleMax.val);
                }

                hipsAutoRotCurrent = Mathf.Lerp(hipsAutoRotStart, hipsAutoRotTarget, autoRotTime);
            }
            else
                hipsAutoRotCurrent = 0;
        }

        protected void UpdateDanceChest()
        {
            if (js_ChestAutoRotate.val)
            {
                autoRotDelay = Mathf.Clamp((stepCycle.GetStep(0).Duration + stepCycle.GetStep(0).Delay) * js_ChestAutoRotDelayMult.val, 0.01f, 1000);
                autoRotTime = Mathf.Clamp01((Time.time - chestAutoRotStartTime) / autoRotDelay);

                if (autoRotTime >= 1)
                {
                    chestAutoRotStartTime = Time.time;
                    autoRotTime = 0;

                    chestAutoRotChange = UnityEngine.Random.Range(js_ChestAutoRotAngleChangeMin.val, js_ChestAutoRotAngleChangeMax.val) * stepCycle.StepInPlaceAmplitude;

                    if (UnityEngine.Random.value > 0.5f)
                        autoRotChange = -autoRotChange;

                    chestAutoRotStart = chestAutoRotTarget;

                    if (chestAutoRotTarget + chestAutoRotChange > js_ChestAutoRotAngleMax.val || chestAutoRotTarget + chestAutoRotChange < -js_ChestAutoRotAngleMin.val)
                        chestAutoRotTarget = Mathf.Clamp(chestAutoRotTarget - chestAutoRotChange, -js_ChestAutoRotAngleMin.val, js_ChestAutoRotAngleMax.val);
                    else
                        chestAutoRotTarget = Mathf.Clamp(chestAutoRotTarget + chestAutoRotChange, -js_ChestAutoRotAngleMin.val, js_ChestAutoRotAngleMax.val);

                }

                chestAutoRotCurrent = Mathf.Lerp(chestAutoRotStart, chestAutoRotTarget, autoRotTime);
            }
            else
                chestAutoRotCurrent = 0;
        }

        protected void UpdateDanceNeck()
        {
            if (js_NeckAutoRotate.val)
            {
                autoRotDelay = Mathf.Clamp((stepCycle.GetStep(0).Duration + stepCycle.GetStep(0).Delay) * js_NeckAutoRotDelayMult.val, 0.01f, 1000);
                autoRotTime = Mathf.Clamp01((Time.time - neckAutoRotStartTime) / autoRotDelay);

                if (autoRotTime >= 1)
                {
                    neckAutoRotStartTime = Time.time;
                    autoRotTime = 0;

                    neckAutoRotChange = UnityEngine.Random.Range(js_NeckAutoRotAngleChangeMin.val, js_NeckAutoRotAngleChangeMax.val) * stepCycle.StepInPlaceAmplitude;

                    if (UnityEngine.Random.value > 0.5f)
                        neckAutoRotChange = -neckAutoRotChange;

                    neckAutoRotStart = neckAutoRotTarget;

                    if (neckAutoRotTarget + neckAutoRotChange > js_NeckAutoRotAngleMax.val || neckAutoRotTarget + neckAutoRotChange < -js_NeckAutoRotAngleMin.val)
                        neckAutoRotTarget = Mathf.Clamp(neckAutoRotTarget - neckAutoRotChange, -js_NeckAutoRotAngleMin.val, js_NeckAutoRotAngleMax.val);
                    else
                        neckAutoRotTarget = Mathf.Clamp(neckAutoRotTarget + neckAutoRotChange, -js_NeckAutoRotAngleMin.val, js_NeckAutoRotAngleMax.val);

                }

                neckAutoRotCurrent = Mathf.Lerp(neckAutoRotStart, neckAutoRotTarget, autoRotTime);
            }
            else
                neckAutoRotCurrent = 0;
        }

        #endregion

        #region UI

        /* UI */

        public override void CreateGlobalUI()
        {
            UIDynamic _spacer;

            base.CreateGlobalUI();

            manager.CreateMainButton("Timing", ShowTimingUI);
            manager.CreateMainButton("Control", ShowBodyControlsUI);                     
            manager.CreateMainButton("DanceMode", ShowDanceUI);
            manager.CreateMainButton("Actions", ShowActionsUI);

            manager.CreateStaticText("Title", "<color=#000><size=35><b>Body Pose</b></size></color>", false, 50);
           
            manager.CreateMainButton("Full Body", ShowAllBodyUI);
            manager.CreateMainButton("Hip", ShowHipsUI);
            manager.CreateMainButton("Chest", ShowChestUI);
            manager.CreateMainButton("Neck", ShowNeckUI);
            manager.CreateMainButton("Right Leg", ShowRightLegUI);
            manager.CreateMainButton("Left Leg", ShowLeftLegUI);
            manager.CreateMainButton("Right Arm", ShowRightArmUI);
            manager.CreateMainButton("Left Arm", ShowLeftArmUI);

            manager.CreateStaticText("Title", "<color=#000><size=35><b>Body Movement</b></size></color>", false, 50);

            manager.CreateMainButton("Zero all step parameters", Callback_ZeroAllStepParameters);

            _spacer = manager.CreateSpacer();
            _spacer.height = 25f;

            manager.CreateMainButton("Full Body", ShowAllBodyStepsUI);
            manager.CreateMainButton("Hip", ShowHipsStepsUI);
            manager.CreateMainButton("Chest", ShowChestStepsUI);
            manager.CreateMainButton("Neck", ShowNeckStepsUI);
            manager.CreateMainButton("Right Leg", ShowRightLegStepsUI);
            manager.CreateMainButton("Left Leg", ShowLeftLegStepsUI);
            manager.CreateMainButton("Right Arm", ShowRightArmStepsUI);
            manager.CreateMainButton("Left Arm", ShowLeftArmStepsUI);

            _spacer = manager.CreateSpacer();
            _spacer.height = 25f;
        }

        protected void ShowTimingUI()
        {
            manager.ClearUI();

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Timing</b></size></color>", 50);

            manager.CreateTempButton("Reset Steps", Callback_ResetStepTime);

            manager.CreateTempSlider(js_StepsDuration);
            manager.CreateTempSlider(js_StepsDelay);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_DurationRandom_Min);
            manager.CreateTempSlider(js_DurationRandom_Max);
            
        }

        protected void ShowActionsUI()
        {
            manager.ClearUI();

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Actions Params</b></size></color>", 50);

            manager.CreateTempSlider(js_Action_StepDurationChange);
            manager.CreateTempSlider(js_Action_DanceAmplitudeChange);
            manager.CreateTempSlider(js_Action_RotationOffsetChange);
        }

        protected void ShowAllBodyUI()
        {
            manager.ClearUI();

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Full Body Pose</b></size></color>", 50);

            manager.CreateTempToggle(js_SwitchStanceAuto);
            manager.CreateTempToggle(js_AutoAdaptHeight);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_BodyHeight);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_BodyYaw);
            manager.CreateTempSlider(js_BodyPitch);
            manager.CreateTempSlider(js_BodyRoll);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_StepsYOffset);
            manager.CreateTempSlider(js_StepsXOffset);
            manager.CreateTempSlider(js_StepsXOffsetIdle);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_XOffsetRandom_Min);
            manager.CreateTempSlider(js_XOffsetRandom_Max);

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Kneeling</b></size></color>", 50);

            manager.CreateTempSlider(js_KneeXOffsetKneelingIdle);
            manager.CreateTempSlider(js_KneeXOffsetKneelingMoving);
            manager.CreateTempSlider(js_KneeYOffsetKneeling);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_LegsYawKneeling);
            manager.CreateTempSlider(js_LegsPitchKneeling);
            manager.CreateTempSlider(js_LegsRollKneeling);

            
        }

        protected void ShowAllBodyStepsUI()
        {
            manager.ClearUI();

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Full Body Movement</b></size></color>", 50);

            manager.CreateTempSlider(js_Step_FullBody_MidPoint);
            manager.CreateTempSlider(js_Step_FullBody_Sharpness);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_Step_BodyHeight);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_Step_BodyYaw);
            manager.CreateTempSlider(js_Step_BodyPitch);
            manager.CreateTempSlider(js_Step_BodyRoll);

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Kneeling</b></size></color>", 50);

            manager.CreateTempSlider(js_KneeStepHeightKneeling);
            manager.CreateTempSlider(js_KneeStepBowKneeling);
        }

        protected void ShowRightLegUI()
        {
            manager.ClearUI();

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Right Leg Pose</b></size></color>", 50);

            manager.CreateTempButton("Mirror", Callback_CopyLeg_RightLeft);    

            manager.CreateTempSlider(js_RFootSide);
            manager.CreateTempSlider(js_RFootUpDown);
            manager.CreateTempSlider(js_RFootForward);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_RFootYaw);
            manager.CreateTempSlider(js_RFootPitch);
            manager.CreateTempSlider(js_RFootRoll);
           

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_RKneeSide);
            manager.CreateTempSlider(js_RKneeUpDown);
            manager.CreateTempSlider(js_RKneeForward);
        }

        protected void ShowRightLegStepsUI()
        {
            manager.ClearUI();

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Right Leg Movement</b></size></color>", 50);

            manager.CreateTempButton("Mirror", Callback_CopyLeg_RightLeft);

            manager.CreateTempSlider(js_Step_RightFoot_MidPoint);
            manager.CreateTempSlider(js_Step_RightFoot_Sharpness);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_RFootStepSide);
            manager.CreateTempSlider(js_RFootStepUpDown);
            manager.CreateTempSlider(js_RFootStepForward);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_RFootStepYaw);
            manager.CreateTempSlider(js_RFootStepPitch);
            manager.CreateTempSlider(js_RFootStepRoll);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_Step_RightKnee_MidPoint);
            manager.CreateTempSlider(js_Step_RightKnee_Sharpness);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_RKneeStepSide);
            manager.CreateTempSlider(js_RKneeStepUpDown);
            manager.CreateTempSlider(js_RKneeStepForward);
        }

        protected void ShowLeftLegUI()
        {
            manager.ClearUI();

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Left Leg Pose</b></size></color>", 50);

            manager.CreateTempButton("Mirror", Callback_CopyLeg_LeftRight);

            manager.CreateTempSlider(js_LFootSide);
            manager.CreateTempSlider(js_LFootUpDown);
            manager.CreateTempSlider(js_LFootForward);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_LFootYaw);
            manager.CreateTempSlider(js_LFootPitch);
            manager.CreateTempSlider(js_LFootRoll);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_LKneeSide);
            manager.CreateTempSlider(js_LKneeUpDown);
            manager.CreateTempSlider(js_LKneeForward);
        }

        protected void ShowLeftLegStepsUI()
        {
            manager.ClearUI();

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Left Leg Movement</b></size></color>", 50);

            manager.CreateTempButton("Mirror", Callback_CopyLeg_LeftRight);

            manager.CreateTempSlider(js_Step_LeftFoot_MidPoint);
            manager.CreateTempSlider(js_Step_LeftFoot_Sharpness);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_LFootStepSide);
            manager.CreateTempSlider(js_LFootStepUpDown);
            manager.CreateTempSlider(js_LFootStepForward);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_LFootStepYaw);
            manager.CreateTempSlider(js_LFootStepPitch);
            manager.CreateTempSlider(js_LFootStepRoll);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_Step_LeftKnee_MidPoint);
            manager.CreateTempSlider(js_Step_LeftKnee_Sharpness);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_LKneeStepSide);
            manager.CreateTempSlider(js_LKneeStepUpDown);
            manager.CreateTempSlider(js_LKneeStepForward);
        }

        protected void ShowHipsUI()
        {
            manager.ClearUI();

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Hips Pose</b></size></color>", 50);

            manager.CreateTempSlider(js_HipsSide);
            manager.CreateTempSlider(js_HipsUpDown);
            manager.CreateTempSlider(js_HipsForward);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_HipsYaw);
            manager.CreateTempSlider(js_HipsPitch);
            manager.CreateTempSlider(js_HipsRoll);          
        }

        protected void ShowHipsStepsUI()
        {
            manager.ClearUI();

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Hips Movement</b></size></color>", 50);

            manager.CreateTempSlider(js_Step_Hips_MidPoint);
            manager.CreateTempSlider(js_Step_Hips_Sharpness);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_HipsStepSide);
            manager.CreateTempSlider(js_HipsStepUpDown);
            manager.CreateTempSlider(js_HipsStepForward);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_HipsStepYaw);
            manager.CreateTempSlider(js_HipsStepPitch);
            manager.CreateTempSlider(js_HipsStepRoll);
        }

        protected void ShowChestUI()
        {
            manager.ClearUI();

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Chest Pose</b></size></color>", 50);

            manager.CreateTempSlider(js_ChestSide);
            manager.CreateTempSlider(js_ChestUpDown);
            manager.CreateTempSlider(js_ChestForward);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_ChestYaw);
            manager.CreateTempSlider(js_ChestPitch);
            manager.CreateTempSlider(js_ChestRoll);
        }

        protected void ShowChestStepsUI()
        {
            manager.ClearUI();

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Chest Movement</b></size></color>", 50);

            manager.CreateTempSlider(js_Step_Chest_MidPoint);
            manager.CreateTempSlider(js_Step_Chest_Sharpness);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_ChestStepSide);
            manager.CreateTempSlider(js_ChestStepUpDown);
            manager.CreateTempSlider(js_ChestStepForward);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_ChestStepYaw);
            manager.CreateTempSlider(js_ChestStepPitch);
            manager.CreateTempSlider(js_ChestStepRoll);
        }

        protected void ShowNeckUI()
        {
            manager.ClearUI();

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Neck Pose</b></size></color>", 50);

            manager.CreateTempSlider(js_NeckSide);
            manager.CreateTempSlider(js_NeckUpDown);
            manager.CreateTempSlider(js_NeckForward);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_NeckYaw);
            manager.CreateTempSlider(js_NeckPitch);
            manager.CreateTempSlider(js_NeckRoll); 
        }

        protected void ShowNeckStepsUI()
        {
            manager.ClearUI();

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Neck Movement</b></size></color>", 50);

            manager.CreateTempSlider(js_Step_Neck_MidPoint);
            manager.CreateTempSlider(js_Step_Neck_Sharpness);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_NeckStepSide);
            manager.CreateTempSlider(js_NeckStepUpDown);
            manager.CreateTempSlider(js_NeckStepForward);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_NeckStepYaw);
            manager.CreateTempSlider(js_NeckStepPitch);
            manager.CreateTempSlider(js_NeckStepRoll);
        }

        protected void ShowLeftArmUI()
        {
            manager.ClearUI();

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Left Arm Pose</b></size></color>", 50);

            manager.CreateTempButton("Mirror", Callback_CopyArm_LeftRight);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_LHandSide);
            manager.CreateTempSlider(js_LHandUpDown);
            manager.CreateTempSlider(js_LHandForward);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_LHandYaw);
            manager.CreateTempSlider(js_LHandPitch);
            manager.CreateTempSlider(js_LHandRoll);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_LShoulderSide);
            manager.CreateTempSlider(js_LShoulderUpDown);
            manager.CreateTempSlider(js_LShoulderForward);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_LElbowSide);
            manager.CreateTempSlider(js_LElbowUpDown);
            manager.CreateTempSlider(js_LElbowForward);
        }

        protected void ShowLeftArmStepsUI()
        {
            manager.ClearUI();

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Left Arm Movement</b></size></color>", 50);

            manager.CreateTempButton("Mirror", Callback_CopyArm_LeftRight);

            manager.CreateTempSlider(js_Step_LeftShoulder_MidPoint);
            manager.CreateTempSlider(js_Step_LeftShoulder_Sharpness);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_LShoulderStepSide);
            manager.CreateTempSlider(js_LShoulderStepUpDown);
            manager.CreateTempSlider(js_LShoulderStepForward);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_Step_LeftHand_MidPoint);
            manager.CreateTempSlider(js_Step_LeftHand_Sharpness);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_LHandStepSide);
            manager.CreateTempSlider(js_LHandStepUpDown);
            manager.CreateTempSlider(js_LHandStepForward);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_LHandStepYaw);
            manager.CreateTempSlider(js_LHandStepPitch);
            manager.CreateTempSlider(js_LHandStepRoll);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_Step_LeftElbow_MidPoint);
            manager.CreateTempSlider(js_Step_LeftElbow_Sharpness);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_LElbowStepSide);
            manager.CreateTempSlider(js_LElbowStepUpDown);
            manager.CreateTempSlider(js_LElbowStepForward);

            
        }

        protected void ShowRightArmUI()
        {
            manager.ClearUI();

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Right Arm Pose</b></size></color>", 50);

            manager.CreateTempButton("Mirror", Callback_CopyArm_RightLeft);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_RHandSide);
            manager.CreateTempSlider(js_RHandUpDown);
            manager.CreateTempSlider(js_RHandForward);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_RHandYaw);
            manager.CreateTempSlider(js_RHandPitch);
            manager.CreateTempSlider(js_RHandRoll);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_RShoulderSide);
            manager.CreateTempSlider(js_RShoulderUpDown);
            manager.CreateTempSlider(js_RShoulderForward);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_RElbowSide);
            manager.CreateTempSlider(js_RElbowUpDown);
            manager.CreateTempSlider(js_RElbowForward);
        }

        protected void ShowRightArmStepsUI()
        {
            manager.ClearUI();

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Right Arm Movement</b></size></color>", 50);

            manager.CreateTempButton("Mirror", Callback_CopyArm_RightLeft);

            manager.CreateTempSlider(js_Step_RightShoulder_MidPoint);
            manager.CreateTempSlider(js_Step_RightShoulder_Sharpness);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_RShoulderStepSide);
            manager.CreateTempSlider(js_RShoulderStepUpDown);
            manager.CreateTempSlider(js_RShoulderStepForward);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_Step_RightHand_MidPoint);
            manager.CreateTempSlider(js_Step_RightHand_Sharpness);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_RHandStepSide);
            manager.CreateTempSlider(js_RHandStepUpDown);
            manager.CreateTempSlider(js_RHandStepForward);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_RHandStepYaw);
            manager.CreateTempSlider(js_RHandStepPitch);
            manager.CreateTempSlider(js_RHandStepRoll);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_Step_RightElbow_MidPoint);
            manager.CreateTempSlider(js_Step_RightElbow_Sharpness);

            manager.CreateTempSpacer(25f);

            manager.CreateTempSlider(js_RElbowStepSide);
            manager.CreateTempSlider(js_RElbowStepUpDown);
            manager.CreateTempSlider(js_RElbowStepForward);

            
        }

        protected void ShowDanceUI()
        {
            manager.ClearUI();

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Dance</b></size></color>", 50);

            manager.CreateTempToggle(js_DanceMode);

            manager.CreateTempSpacer(25f);

            manager.CreateTempToggle(js_MoveKneesOnBothSteps);
            manager.CreateTempToggle(js_MoveFeetOnBothSteps);


            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Movement Amplitude</b></size></color>", 40);

            manager.CreateTempSlider(js_DanceAmplitude);

            manager.CreateTempSpacer(25f);

            manager.CreateTempToggle(js_RandomAmplitude);
            manager.CreateTempSlider(js_DanceAmplitudeDelayMult);
            manager.CreateTempSlider(js_DanceAmplitudeChange);
            manager.CreateTempSlider(js_DanceAmplitudeChangeLimit);         


            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Fullbody Auto Rotate</b></size></color>", 40);

            manager.CreateTempToggle(js_AutoRotate);
            manager.CreateTempSlider(js_AutoRotDelayMult);
            manager.CreateTempSlider(js_AutoRotAngleChangeMin);
            manager.CreateTempSlider(js_AutoRotAngleChangeMax);
            manager.CreateTempSlider(js_AutoRotAngleMin);
            manager.CreateTempSlider(js_AutoRotAngleMax);

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Hips Auto Rotate</b></size></color>", 40);

            manager.CreateTempToggle(js_HipsAutoRotate);
            manager.CreateTempSlider(js_HipsAutoRotDelayMult);
            manager.CreateTempSlider(js_HipsAutoRotAngleChangeMin);
            manager.CreateTempSlider(js_HipsAutoRotAngleChangeMax);
            manager.CreateTempSlider(js_HipsAutoRotAngleMin);
            manager.CreateTempSlider(js_HipsAutoRotAngleMax);

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Chest Auto Rotate</b></size></color>", 40);

            manager.CreateTempToggle(js_ChestAutoRotate);
            manager.CreateTempSlider(js_ChestAutoRotDelayMult);
            manager.CreateTempSlider(js_ChestAutoRotAngleChangeMin);
            manager.CreateTempSlider(js_ChestAutoRotAngleChangeMax);
            manager.CreateTempSlider(js_ChestAutoRotAngleMin);
            manager.CreateTempSlider(js_ChestAutoRotAngleMax);

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Neck Auto Rotate</b></size></color>", 40);

            manager.CreateTempToggle(js_NeckAutoRotate);
            manager.CreateTempSlider(js_NeckAutoRotDelayMult);
            manager.CreateTempSlider(js_NeckAutoRotAngleChangeMin);
            manager.CreateTempSlider(js_NeckAutoRotAngleChangeMax);
            manager.CreateTempSlider(js_NeckAutoRotAngleMin);
            manager.CreateTempSlider(js_NeckAutoRotAngleMax);
        }

        protected void ShowBodyControlsUI()
        {
            manager.ClearUI();

            manager.CreateTempStaticText("Title", "<color=#000><size=35><b>Body Controls</b></size></color>", 50);

            manager.CreateTempButton("Set Default Controllers", SetDefaultControllersState);
            manager.CreateTempStaticText("Info", "<color=#000><size=25>Click to set optimal body controls state</size></color>", 50);

            manager.CreateTempSpacer(25f);

            manager.CreateTempButton("Update Body Proportions", UpdateBodyProportions);
            manager.CreateTempStaticText("Info", "<color=#000><size=25>Click this when you change your character proportions!!</size></color>", 85);

            manager.CreateTempSpacer(25f);         

            manager.CreateTempToggle(js_UpdateRootControl);

            manager.CreateTempStaticText("Info", "<color=#000><size=25>For the main control to work correctly, be sure to toggle the Detach Person Root Control On (In the Control & Physics Tab) </size></color>", 120);

            manager.CreateTempSpacer(25f);

            manager.CreateTempToggle(js_StopControlingWhenIdle);
            manager.CreateTempStaticText("Info", "<color=#000><size=25>CLS will stop control when the character is Idle</size></color>", 85);

            manager.CreateTempSpacer(25f);

            manager.CreateTempToggle(js_UpdateHipControl);
            manager.CreateTempToggle(js_UpdateChestControl);
            manager.CreateTempToggle(js_UpdateNeckControl);

            manager.CreateTempSpacer(25f);

            manager.CreateTempToggle(js_UpdateRFootControl);
            manager.CreateTempToggle(js_UpdateRKneeControl);
            manager.CreateTempToggle(js_UpdateLFootControl);
            manager.CreateTempToggle(js_UpdateLKneeControl);

            manager.CreateTempSpacer(25f);

            manager.CreateTempToggle(js_UpdateRShoulderControl);
            manager.CreateTempToggle(js_UpdateRHandControl);
            manager.CreateTempToggle(js_UpdateRElbowControl);

            manager.CreateTempSpacer(25f);

            manager.CreateTempToggle(js_UpdateLShoulderControl);
            manager.CreateTempToggle(js_UpdateLHandControl);
            manager.CreateTempToggle(js_UpdateLElbowControl);
        }

        public override void BodyControllerPresetsUI()
        {
            manager.CreateTempSpacer(25f);

            manager.CreateTempToggle(js_TogglePresetUpdate_StepDuration);
            manager.CreateTempToggle(js_TogglePresetUpdate_DanceAmplitude);
        }

        public override void BodyControllerTriggersUI()
        {

        }

        public override void BodyControllerMovementUI()
        {

        }

        #endregion

        #region Preset System

        /* Presets */

        protected List<JSONStorableFloat> floatStorables;
        protected List<JSONStorableBool> boolStorables;

        protected BodyControllerDataSet presetLoadStartData, presetLoadEndData;
        protected bool presetTransitionActive = false;
        protected float presetTransitionStartTime = 0;

        public override JSONClass GetAllBodyParameters()
        {
            JSONClass _saveJSON = new JSONClass();

            _saveJSON["FloatParameters"] = new JSONArray();
            _saveJSON["BoolParameters"] = new JSONArray();

            for (int i = 0; i < floatStorables.Count; i++)
            {
                _saveJSON["FloatParameters"].Add(floatStorables[i].val.ToString());
            }

            for (int i = 0; i < boolStorables.Count; i++)
            {
                _saveJSON["BoolParameters"].Add(boolStorables[i].val.ToString());
            }


            return _saveJSON;
        }

        public override void SetAllParametersFromSaveFile(JSONNode _saveJSON)
        {
            for(int i = 0; i < floatStorables.Count; i++)
            {
                if (i >= _saveJSON["FloatParameters"].Count)
                    break;

                presetLoadStartData.floatData[i] = floatStorables[i].val;
                presetLoadEndData.floatData[i] = _saveJSON["FloatParameters"][i].AsFloat;
            }

            for(int i = 0; i < boolStorables.Count; i++)
            {
                if (i >= _saveJSON["BoolParameters"].Count)
                    break;

                boolStorables[i].val = _saveJSON["BoolParameters"][i].AsBool;
            }

            presetTransitionActive = true;
            presetTransitionStartTime = Time.time;
        }

        public void CreateJSONStorableLists()
        {
            floatStorables = new List<JSONStorableFloat>();
            boolStorables = new List<JSONStorableBool>();

            floatStorables.Add(js_BodyHeight); //1
            floatStorables.Add(js_BodyPitch);//2
            floatStorables.Add(js_BodyYaw);//3
            floatStorables.Add(js_BodyRoll);//4
            floatStorables.Add(js_Step_BodyHeight);//5
            floatStorables.Add(js_Step_BodyPitch);//6
            floatStorables.Add(js_Step_BodyYaw);//7
            floatStorables.Add(js_Step_BodyRoll);//8
            floatStorables.Add(js_LHandStepPitch);//9

            /* Old float storables / Used to keep presets compatibility */

            floatStorables.Add(js_TrashFloat);//10

            /* END Trash */

            floatStorables.Add(js_LHandStepRoll);//11
            floatStorables.Add(js_StepsDuration);//12
            floatStorables.Add(js_StepsXOffset);//13
            floatStorables.Add(js_StepsXOffsetIdle);//14
            floatStorables.Add(js_StepsYOffset);//15

            floatStorables.Add(js_DanceAmplitude);//16
            floatStorables.Add(js_LHandStepYaw);//17

            /* Old float storables / Used to keep presets compatibility */

            floatStorables.Add(js_TrashFloat);//18
            floatStorables.Add(js_TrashFloat);//19
            floatStorables.Add(js_TrashFloat);//20
            floatStorables.Add(js_TrashFloat);//21
            floatStorables.Add(js_TrashFloat);//22
            floatStorables.Add(js_TrashFloat);//23
            floatStorables.Add(js_TrashFloat);//24
            floatStorables.Add(js_TrashFloat);//25
            floatStorables.Add(js_TrashFloat);//26

            /* END Trash */

            floatStorables.Add(js_LFootSide);//27
            floatStorables.Add(js_LFootUpDown);//28
            floatStorables.Add(js_LFootForward);//29
            floatStorables.Add(js_LFootPitch);//30
            floatStorables.Add(js_LFootRoll);//31
            floatStorables.Add(js_LFootYaw);//32
            floatStorables.Add(js_LFootStepSide);//33
            floatStorables.Add(js_LFootStepUpDown);//34
            floatStorables.Add(js_LFootStepForward);//35
            floatStorables.Add(js_LFootStepPitch);//36
            floatStorables.Add(js_LFootStepRoll);//37
            floatStorables.Add(js_LFootStepYaw);//38

            floatStorables.Add(js_RFootSide);//39
            floatStorables.Add(js_RFootUpDown);//40
            floatStorables.Add(js_RFootForward);//41
            floatStorables.Add(js_RFootPitch);//42
            floatStorables.Add(js_RFootRoll);//43
            floatStorables.Add(js_RFootYaw);//44
            floatStorables.Add(js_RFootStepSide);//45
            floatStorables.Add(js_RFootStepUpDown);//46
            floatStorables.Add(js_RFootStepForward);//47
            floatStorables.Add(js_RFootStepPitch);//48
            floatStorables.Add(js_RFootStepRoll);//49
            floatStorables.Add(js_RFootStepYaw);//50

            floatStorables.Add(js_HipsSide);//51
            floatStorables.Add(js_HipsUpDown);//52
            floatStorables.Add(js_HipsForward);//53
            floatStorables.Add(js_HipsYaw);//54
            floatStorables.Add(js_HipsPitch);//55
            floatStorables.Add(js_HipsRoll);//56
            floatStorables.Add(js_HipsStepSide);//57
            floatStorables.Add(js_HipsStepUpDown);//58
            floatStorables.Add(js_HipsStepForward);//59
            floatStorables.Add(js_HipsStepYaw);//60
            floatStorables.Add(js_HipsStepPitch);//61
            floatStorables.Add(js_HipsStepRoll);//62

            floatStorables.Add(js_ChestSide);//63
            floatStorables.Add(js_ChestUpDown);//64
            floatStorables.Add(js_ChestForward);//65
            floatStorables.Add(js_ChestYaw);//66
            floatStorables.Add(js_ChestPitch);//67
            floatStorables.Add(js_ChestRoll);//68
            floatStorables.Add(js_ChestStepSide);//69
            floatStorables.Add(js_ChestStepUpDown);//70
            floatStorables.Add(js_ChestStepForward);//71
            floatStorables.Add(js_ChestStepPitch);//72
            floatStorables.Add(js_ChestStepRoll);//73
            floatStorables.Add(js_ChestStepYaw);//74

            floatStorables.Add(js_NeckSide);//75
            floatStorables.Add(js_NeckUpDown);//76
            floatStorables.Add(js_NeckForward);//77
            floatStorables.Add(js_NeckYaw);//78
            floatStorables.Add(js_NeckPitch);//79
            floatStorables.Add(js_NeckRoll);//80
            floatStorables.Add(js_NeckStepSide);//81
            floatStorables.Add(js_NeckStepUpDown);//82
            floatStorables.Add(js_NeckStepForward);//83
            floatStorables.Add(js_NeckStepPitch);//84
            floatStorables.Add(js_NeckStepRoll);//85
            floatStorables.Add(js_NeckStepYaw);//86

            floatStorables.Add(js_LKneeSide);//87
            floatStorables.Add(js_LKneeUpDown);//88
            floatStorables.Add(js_LKneeForward);//89
            floatStorables.Add(js_LKneeStepSide);
            floatStorables.Add(js_LKneeStepUpDown);
            floatStorables.Add(js_LKneeStepForward);
            floatStorables.Add(js_RKneeSide);
            floatStorables.Add(js_RKneeUpDown);
            floatStorables.Add(js_RKneeForward);
            floatStorables.Add(js_RKneeStepSide);
            floatStorables.Add(js_RKneeStepUpDown);
            floatStorables.Add(js_RKneeStepForward);

            floatStorables.Add(js_KneeXOffsetKneelingMoving);
            floatStorables.Add(js_KneeXOffsetKneelingIdle);
            floatStorables.Add(js_KneeYOffsetKneeling);

            floatStorables.Add(js_KneeStepHeightKneeling);
            floatStorables.Add(js_KneeStepBowKneeling);
            floatStorables.Add(js_LegsYawKneeling);
            floatStorables.Add(js_LegsPitchKneeling);
            floatStorables.Add(js_LegsRollKneeling);

            floatStorables.Add(js_RShoulderSide);
            floatStorables.Add(js_RShoulderUpDown);
            floatStorables.Add(js_RShoulderForward);
            floatStorables.Add(js_RHandSide);
            floatStorables.Add(js_RHandUpDown);
            floatStorables.Add(js_RHandForward);
            floatStorables.Add(js_RHandYaw);
            floatStorables.Add(js_RHandPitch);
            floatStorables.Add(js_RHandRoll);
            floatStorables.Add(js_RShoulderStepSide);
            floatStorables.Add(js_RShoulderStepUpDown);
            floatStorables.Add(js_RShoulderStepForward);
            floatStorables.Add(js_RHandStepSide);
            floatStorables.Add(js_RHandStepUpDown);
            floatStorables.Add(js_RHandStepForward);
            floatStorables.Add(js_RHandStepYaw);
            floatStorables.Add(js_RHandStepPitch);
            floatStorables.Add(js_RHandStepRoll);
            floatStorables.Add(js_RElbowSide);
            floatStorables.Add(js_RElbowUpDown);
            floatStorables.Add(js_RElbowForward);
            floatStorables.Add(js_RElbowStepSide);
            floatStorables.Add(js_RElbowStepUpDown);
            floatStorables.Add(js_RElbowStepForward);

            floatStorables.Add(js_LShoulderSide);
            floatStorables.Add(js_LShoulderUpDown);
            floatStorables.Add(js_LShoulderForward);
            floatStorables.Add(js_LHandSide);
            floatStorables.Add(js_LHandUpDown);
            floatStorables.Add(js_LHandForward);
            floatStorables.Add(js_LHandYaw);
            floatStorables.Add(js_LHandPitch);
            floatStorables.Add(js_LHandRoll);
            floatStorables.Add(js_LShoulderStepSide);
            floatStorables.Add(js_LShoulderStepUpDown);
            floatStorables.Add(js_LShoulderStepForward);
            floatStorables.Add(js_LHandStepSide);
            floatStorables.Add(js_LHandStepUpDown);
            floatStorables.Add(js_LHandStepForward);
            floatStorables.Add(js_LElbowSide);
            floatStorables.Add(js_LElbowUpDown);
            floatStorables.Add(js_LElbowForward);
            floatStorables.Add(js_LElbowStepSide);
            floatStorables.Add(js_LElbowStepUpDown);
            floatStorables.Add(js_LElbowStepForward);

            floatStorables.Add(js_Step_FullBody_MidPoint);
            floatStorables.Add(js_Step_FullBody_Sharpness);

            floatStorables.Add(js_Step_Hips_MidPoint);
            floatStorables.Add(js_Step_Hips_Sharpness);

            floatStorables.Add(js_Step_Chest_MidPoint);
            floatStorables.Add(js_Step_Chest_Sharpness);

            floatStorables.Add(js_Step_Neck_MidPoint);
            floatStorables.Add(js_Step_Neck_Sharpness);

            floatStorables.Add(js_Step_LeftHand_MidPoint);
            floatStorables.Add(js_Step_LeftHand_Sharpness);
            floatStorables.Add(js_Step_LeftElbow_MidPoint);
            floatStorables.Add(js_Step_LeftElbow_Sharpness);
            floatStorables.Add(js_Step_LeftShoulder_MidPoint);
            floatStorables.Add(js_Step_LeftShoulder_Sharpness);

            floatStorables.Add(js_Step_RightHand_MidPoint);
            floatStorables.Add(js_Step_RightHand_Sharpness);
            floatStorables.Add(js_Step_RightElbow_MidPoint);
            floatStorables.Add(js_Step_RightElbow_Sharpness);
            floatStorables.Add(js_Step_RightShoulder_MidPoint);
            floatStorables.Add(js_Step_RightShoulder_Sharpness);

            floatStorables.Add(js_DurationRandom_Min);
            floatStorables.Add(js_DurationRandom_Max);
            floatStorables.Add(js_XOffsetRandom_Min);
            floatStorables.Add(js_XOffsetRandom_Max);

            floatStorables.Add(js_AutoRotAngleChangeMin);
            floatStorables.Add(js_AutoRotAngleChangeMax);
            floatStorables.Add(js_AutoRotAngleMin);
            floatStorables.Add(js_AutoRotAngleMax);
            floatStorables.Add(js_AutoRotDelayMult);

            floatStorables.Add(js_HipsAutoRotAngleChangeMin);
            floatStorables.Add(js_HipsAutoRotAngleChangeMax);
            floatStorables.Add(js_HipsAutoRotAngleMin);
            floatStorables.Add(js_HipsAutoRotAngleMax);
            floatStorables.Add(js_HipsAutoRotDelayMult);

            floatStorables.Add(js_ChestAutoRotAngleChangeMin);
            floatStorables.Add(js_ChestAutoRotAngleChangeMax);
            floatStorables.Add(js_ChestAutoRotAngleMin);
            floatStorables.Add(js_ChestAutoRotAngleMax);
            floatStorables.Add(js_ChestAutoRotDelayMult);

            floatStorables.Add(js_NeckAutoRotAngleChangeMin);
            floatStorables.Add(js_NeckAutoRotAngleChangeMax);
            floatStorables.Add(js_NeckAutoRotAngleMin);
            floatStorables.Add(js_NeckAutoRotAngleMax);
            floatStorables.Add(js_NeckAutoRotDelayMult);

            floatStorables.Add(js_DanceAmplitudeChange);
            floatStorables.Add(js_DanceAmplitudeChangeLimit);
            floatStorables.Add(js_DanceAmplitudeDelayMult);

            floatStorables.Add(js_StepsDelay);

            floatStorables.Add(js_Action_StepDurationChange);
            floatStorables.Add(js_Action_DanceAmplitudeChange);
            floatStorables.Add(js_Action_RotationOffsetChange);

            /* Bool storables */

            boolStorables.Add(js_DanceMode); //0
            boolStorables.Add(js_SwitchStanceAuto); //1
            boolStorables.Add(js_MoveKneesOnBothSteps); //2
            boolStorables.Add(js_MoveFeetOnBothSteps); //3
            boolStorables.Add(js_AutoAdaptHeight); //4
             
            boolStorables.Add(js_UpdateHipControl); //5
            boolStorables.Add(js_UpdateChestControl); //6
            boolStorables.Add(js_UpdateNeckControl); //7

            boolStorables.Add(js_UpdateRFootControl); //8
            boolStorables.Add(js_UpdateLFootControl); //9
            boolStorables.Add(js_UpdateRKneeControl); //10
            boolStorables.Add(js_UpdateLKneeControl);  //11

            boolStorables.Add(js_UpdateRShoulderControl); //12
            boolStorables.Add(js_UpdateLShoulderControl); //13
            boolStorables.Add(js_UpdateRHandControl); //14
            boolStorables.Add(js_UpdateLHandControl); //15
            boolStorables.Add(js_UpdateRElbowControl); //16
            boolStorables.Add(js_UpdateLElbowControl); //17

            boolStorables.Add(js_AutoRotate); //18
            boolStorables.Add(js_HipsAutoRotate); //19
            boolStorables.Add(js_ChestAutoRotate); //20
            boolStorables.Add(js_NeckAutoRotate); //21
            boolStorables.Add(js_RandomAmplitude); //22

            boolStorables.Add(js_TogglePresetUpdate_StepDuration); //23
            boolStorables.Add(js_TogglePresetUpdate_DanceAmplitude); //24
        }

        #endregion

    }



    public class BodyControllerDataSet
    {
        public float[] floatData;
        public bool[] boolData;

        public BodyControllerDataSet()
        {
            floatData = new float[300];
            boolData = new bool[50];
        }
    }

}